
$Console
$Embed:'./SPLASH.PNG','splashimg'
$Embed:'./LOGO.V4.PNG','xlogo'
$Embed:'./VCR.TTF','myfont'

Type SVIDHeaderType
    ID As String * 4
    VTYPE As _Unsigned _Byte
    BPP As _Unsigned _Byte
    FPS As _Unsigned _Byte
    SpriteWidth As _Unsigned _Byte
    SpriteHeight As _Unsigned _Byte
    FrameWidth As _Unsigned Integer
    FrameHeight As _Unsigned Integer
    NumFrames As _Unsigned Long
    HINT As String * 1
    EXTRA As String * 14
End Type

Type MovieType
    XRes As Integer
    YRes As Integer
    HINT As String * 1
End Type

Type BMPHeaderType
    id As String * 2 'Should be "BM"
    size As Long 'Size of the data
    rr1 As Integer '
    rr2 As Integer '
    offset As Long 'Position of start of pixel data
    horz As Long '
    wid As Long 'Image width
    hei As Long 'Image height
    planes As Integer '
    bpp As Integer 'Should read 8 for a 256 colour image
    pakbyte As Long '
    imagebytes As Long 'Width*Height
    xres As Long '
    yres As Long '
    colch As Long '
    ic As Long '
    pal As String * 1024 'Stored as &amp;lt;Blue, Green, Red, 0&amp;gt;
End Type

Type VPALTYPE
    GB As _Unsigned _Byte
    R As _Unsigned _Byte
End Type

RES_CHOICES:
Data 160,112,192,128,96,160,80,144,320,112,320,88,224,112,224,196

Choice_Hints:
Data "N","N","T","T","D","D","D","D"

VERA_DEFAULT:
Data 0,0,255,15,0,8,254,10,76,12,197,0,10,0,231,14,133,13,64,6,119,15,51,3,119,7,246,10,143,0,187,11,0,0,17,1,34,2,51,3,68,4,85,5,102,6,119,7,136,8,153,9,170,10,187,11,204,12,221,13,238
Data 14,255,15,17,2,51,4,68,6,102,8,136,10,153,12,187,15,17,2,34,4,51,6,68,8,85,10,102,12,119,15,0,2,17,4,17,6,34,8,34,10,51,12,51,15,0,2,0,4,0,6,0,8,0,10,0,12,0,15,33,2,67,4,100,6,134,8
Data 168,10,201,12,235,15,17,2,50,4,83,6,116,8,149,10,182,12,215,15,16,2,49,4,81,6,98,8,130,10,163,12,195,15,16,2,48,4,64,6,96,8,128,10,144,12,176,15,33,1,67,3,100,5,134,7,168,9,201,11,251
Data 13,33,1,66,3,99,4,132,6,165,8,198,9,247,11,32,1,65,2,97,4,130,5,162,6,195,8,243,9,32,1,64,2,96,3,128,4,160,5,192,6,240,7,33,1,67,3,101,4,134,6,168,8,202,9,252,11,33,1,66,2,100,3,133
Data 4,166,5,200,6,249,7,32,0,65,1,98,1,131,2,164,2,197,3,246,3,32,0,65,0,97,0,130,0,162,0,195,0,243,0,34,1,68,3,102,4,136,6,170,8,204,9,255,11,34,1,68,2,102,3,136,4,170,5,204,6,255,7,34
Data 0,68,1,102,1,136,2,170,2,204,3,255,3,34,0,68,0,102,0,136,0,170,0,204,0,255,0,18,1,52,3,86,4,104,6,138,8,172,9,207,11,18,1,36,2,70,3,88,4,106,5,140,6,159,7,2,0,20,1,38,1,56,2,74,2,92
Data 3,111,3,2,0,20,0,22,0,40,0,42,0,60,0,63,0,18,1,52,3,70,5,104,7,138,9,156,11,191,13,18,1,36,3,54,4,72,6,90,8,108,9,127,11,2,1,20,2,22,4,40,5,42,6,60,8,63,9,2,1,4,2,6,3,8,4,10,5,12,6
Data 15,7,18,2,52,4,70,6,104,8,138,10,156,12,190,15,17,2,35,4,53,6,71,8,89,10,107,12,125,15,1,2,19,4,21,6,38,8,40,10,58,12,60,15,1,2,3,4,4,6,6,8,8,10,9,12,11,15

Common Shared ImageWidth
Common Shared ImageHeight
Common Shared SprWidth
Common Shared SprHeight
Common Shared Palsize
Common Shared UsedCols$
Common Shared MovieName$
Common Shared MovieFPS$
Common Shared TName$
Common Shared TPath$
Common Shared DName$
Common Shared HomeDir$
Common Shared ProjectHome$
Common Shared ProjectDir$
Common Shared Slash$
Common Shared CopyCmd$
Common Shared MoveCmd$
Common Shared SystemOpen$
Common Shared NULL$
Common Shared UseExisting
Common Shared UsingPalette
Common Shared ProjectFPS%
Common Shared Make4BPP
Common Shared GrayScaleVideo
Common Shared UseDither
Common Shared DoHighRes
Common Shared NO_PALETTE_SHIFTING
Common Shared Is_Gray_Video
Common Shared MyScreen&
Common Shared Myfont&
Common Shared FormatChoice
Common Shared Wipe_TMP_Files
Common Shared Bit_Map_Mode
Common Shared ReturnChoice

Dim Shared Magick$
Dim Shared wid
Dim Shared hei
Dim Shared Show&, Show2&
Dim Shared sizex_bpp

ReDim Shared ImageData(0) As _Unsigned _Byte
ReDim Shared ImageDataX_BPP(0) As _Unsigned _Byte
ReDim Shared Sprite(0 To ((SprWidth * SprHeight) - 1)) As _Unsigned _Byte
ReDim Shared Sprite4BPP(0 To (((SprWidth * SprHeight) / 2) - 1)) As _Unsigned _Byte
ReDim Shared VERAPALX_BPP(0) As VPALTYPE


Const BW_MODE = 0
Const GRAY_MODE = 1
Const GREEN_MODE = 2
Const AMBER_MODE = 3
Const COLOR_MODE = 32

Dim Shared X_BITS As Integer
Dim Shared X_PALMODE As Integer

Dim Shared VERAPAL(0 To 255) As VPALTYPE
Dim Shared VERAPALDEFAULT(0 To 255) As VPALTYPE
Dim Shared VERAPAL4BPP(0 To 15) As VPALTYPE

Dim Shared ImagePalette(0 To 255) As Long
Dim Shared FrameCount As _Unsigned Long
Dim Shared FrameExt$
Dim Shared XImage&

Dim Shared CString(0 To 15) As String
Dim Shared CString_AKA(0 To 15) As String

Dim Shared VideoHeader As SVIDHeaderType
Dim Shared MovieChoice(1 To 12) As MovieType

Wipe_TMP_Files = 0

Restore VERA_DEFAULT
For I = 0 To 255
    Read VERAPALDEFAULT(I).GB
    Read VERAPALDEFAULT(I).R
Next

Restore RES_CHOICES
For I = 1 To 8
    Read MovieChoice(I).XRes
    Read MovieChoice(I).YRes
Next
Restore Choice_Hints
For I = 1 To 8
    Read MovieChoice(I).HINT
Next

VideoHeader.ID = "SPRV"
VideoHeader.VTYPE = 1

CString(0) = "BLACK"
CString(1) = "BLUE"
CString(2) = "GREEN"
CString(3) = "CYAN"
CString(4) = "RED"
CString(5) = "PURPLE"
CString(6) = "ORANGE"
CString(7) = "GRAY 1"
CString(8) = "GRAY 2"
CString(9) = "LIGHT BLUE"
CString(10) = "LIGHT GREEN"
CString(11) = "LIGHT CYAN"
CString(12) = "LIGHT RED"
CString(13) = "MAGENTA"
CString(14) = "YELLOW"
CString(15) = "WHITE"

CString_AKA(0) = "BLK"
CString_AKA(1) = "BLU"
CString_AKA(2) = "GRN"
CString_AKA(3) = "CYN"
CString_AKA(4) = "RED"
CString_AKA(5) = "PURP"
CString_AKA(6) = "ORG"
CString_AKA(7) = "LIGHT GRAY"
CString_AKA(8) = "DARK GRAY"
CString_AKA(9) = "LIGHT BLU"
CString_AKA(10) = "LIGHT GRN"
CString_AKA(11) = "LIGHT CYN"
CString_AKA(12) = "LIGHT RED"
CString_AKA(13) = "MAG"
CString_AKA(14) = "YEL"
CString_AKA(15) = "WHT"


$If WINDOWS Then
    Slash$ = "\"
    NULL$ = "NUL"
    CopyCmd$ = "COPY "
    MoveCmd$ = "MOVE "
    SystemOpen$ = "START "
    HomeDir$=_DIR$("APPDATA")
    HomeDir$=LEFT$(HomeDir$,(LEN(HomeDir$)-1))
$Else
    Slash$ = "/"
    NULL$ = "/dev/null"
    CopyCmd$ = "cp "
    MoveCmd$ = "mv "
    HomeDir$ = Environ$("HOME")
    $If MAC Then
        SystemOpen$="open "
    $Else
        SystemOpen$ = "xdg-open "
    $End If
$End If

_Dest _Console
CONSOLE_LOGO
Print
Color 15: Print " X16 Movie Maker": Print


Myfont& = _LoadFont(_Embedded$("myfont"), 20, "MEMORY|MONO|BOLD")

ProjectHome$ = HomeDir$ + Slash$ + "x16vidprojects"

If Not _DirExists(ProjectHome$) Then
    MkDir ProjectHome$
End If

CheckProjectSubDirs

CountFile$ = ProjectHome$ + Slash$ + "mm.run.cnt"
If _FileExists(CountFile$) Then
    Open CountFile$ For Input As #7
    Input #7, RunCount
    Close #7
    RunCount = RunCount + 1
Else
    RunCount = 1
End If

Open CountFile$ For Output As #7
Print #7, RunCount
Close #7

XImage& = _LoadImage(_Embedded$("xlogo"), , "MEMORY")
_PaletteColor 1, _RGB32(0, 0, 250)
_Title "X16 Movie Maker"

ChDir _StartDir$

If _CommandCount > 1 Then BadCommandLine
If _CommandCount = 0 Then GoTo skipprocesscommandline
TName$ = Command$(1)

tmp$ = GetFilePath(TName$)

If _FileExists(TName$) And (tmp$ = "") Then
    TName$ = _StartDir$ + Slash$ + TName$
End If

GoTo StartMeUp1

skipprocesscommandline:
If RunCount < 5 Then ShowSplash

Choice = GetUserChoice

If Choice = 2 Then
    TFolder$ = _SelectFolderDialog$("SELECT FRAME DIRECTORY", ProjectHome$)
    If TFolder$ = "" Then System
    TPath$ = TFolder$
    ChDir TFolder$
    InFrameFolder = -1
    UseExisting = -1
    DName$ = TFolder$
    SetUpMovieParameters
    GoTo StartMeUp2
End If

TName$ = _OpenFileDialog$("X16 Movie Maker - Select Video File to Convert", "", "*.mpg|*.MPG|*.mpeg|*.MPEG|*.MP4|*.mp4|*.mkv|*.MKV|*.avi|*.AVI", "Movie Files", -1)

If TName$ = "" Then System
DName$ = TName$

StartMeUp1:
SetUpMovieParameters

If Not UseExisting Then
    Wipe_TMP_Files = Get_WipeOutChoice
    PName$ = GetFileName(TName$)
    ChDir ProjectHome$
    If Bit_Map_Mode Then
        subpath$ = "BITMAP" + Slash$
        Select Case VideoHeader.BPP
            Case 1
                subpath$ = subpath$ + "1BPP"
            Case 2
                subpath$ = subpath$ + "2BPP"
            Case 4
                subpath$ = subpath$ + "4BPP"
            Case 8
                subpath$ = subpath$ + "8BPP"
        End Select
        GoTo skipoverpaths
    End If

    subpath$ = "8BPP"
    VideoHeader.BPP = 8
    If Make4BPP Then subpath$ = "4BPP": VideoHeader.BPP = 4
    If GrayScaleVideo Then subpath$ = "GRAYSCALE"

    skipoverpaths:
    TPath$ = subpath$ + Slash$ + GetFileName(TName$)
    Print _CWD$
    Print TPath$
    If _DirExists(TPath$) Then
        ChDir TPath$
    Else
        MkDir TPath$
        ChDir TPath$
    End If
    If Not _DirExists("frames") Then
        MkDir "frames"
    End If
    FFMpeg_ExtractFrames
    ChDir "frames"
    NewProj = -1
End If


StartMeUp2:
CheckForFrames

If FrameCount = 0 Then
    Beep
    _Dest _Console
    Print "No framefiles found !"
    Print
    _Dest 0
    Print "No framefiles found !"
    Print
    _MessageBox "NO FRAME FILES", "No frame files were found at: " + TPath$, "error"
    End
Else
    Print
    Print " "; FrameCount; " Frames"
    VideoHeader.NumFrames = FrameCount
End If

SetUpMovieParameters
SetMyScreen 800, 320
_Title "X16 Movie Maker - Starting Conversion"
Color 15, 1
Cls
For I = 1 To 8: Print: Next
ShowLogo
_Dest 0
Print
Color 14
Print FrameCount;
Color 15
Print " " + FrameExt$;
Color 7
Print " frames."
_Dest _Console
Cls
Print
Color 3
Print "Converting " + DName$
Locate 10, 1
Print
Color 9
Print FrameCount;
Color 3
Print " " + FrameExt$ + " frames."

MovieName$ = GetTargetName
AudioTrackName$ = GetFileName(MovieName$) + ".SVA"
If NewProj Then
    Pref$ = ".." + Slash$: MovieName$ = Pref$ + MovieName$: AudioTrackName$ = Pref$ + AudioTrackName$
    TargetName$ = AudioTrackName$
    If InStr(TargetName$, Chr$(32)) > 0 Then TargetName$ = Chr$(34) + TargetName$ + Chr$(34)
    CMD$ = MoveCmd$ + Pref$ + "audio.out " + TargetName$
    Shell CMD$
End If

X = _MessageBox("Preview ?", "Show preview window while converting ?", "yesno", "question", 0)
WantsPreview = (X = 1)

SetMyScreen 900, 620
_Title "Converting - " + GetFileName(MovieName$) + " (" + _Trim$(Str$(FrameCount)) + " frames)"
ShowStats

If _FileExists(MovieName$) Then Kill MovieName$

Open MovieName$ For Binary As #3

Put #3, , VideoHeader

SUFFIX$ = "0000000"
For i& = 1 To FrameCount
    If i& = 10 Then SUFFIX$ = "000000"
    If i& = 100 Then SUFFIX$ = "00000"
    If i& = 1000 Then SUFFIX$ = "0000"
    If i& = 10000 Then SUFFIX$ = "000"
    If i& = 100000 Then SUFFIX$ = "00"
    DOFILE$ = SUFFIX$ + Mid$(Str$(i&), 2) + FrameExt$
    LoadImage DOFILE$
    If Bit_Map_Mode Then
        If X_PALMODE = GREEN_MODE Then InjectGreenPal
        If X_PALMODE = AMBER_MODE Then InjectAmberPal
    End If
    If WantsPreview Then Showit
    If Bit_Map_Mode Then
        DownSampleImage
        Put #3, , ImageDataX_BPP()
        If UsingPalette Then Put #3, , VERAPALX_BPP()
        GoTo nextframe
    Else
        For Y = 0 To (ImageHeight - SprHeight) Step SprHeight
            For X = 0 To (ImageWidth - SprWidth) Step SprWidth
                GetSprite X, Y
                If Make4BPP Then
                    Make4bitSprite
                    Put #3, , Sprite4BPP()
                Else
                    Put #3, , Sprite()
                End If
            Next
        Next
    End If
    If UsingPalette Then
        If Make4BPP Then
            Grab4BitPalette
            Put #3, , VERAPAL4BPP()
        Else
            Put #3, , VERAPAL()
        End If
    End If

    nextframe:
    If Wipe_TMP_Files Then Kill DOFILE$
    Z = _KeyHit
    If Z = 34304 Then SAVESAMPLEBIN i&

Next

Close 3
_Dest _Console
Cls
Print
CONSOLE_LOGO
Print
Color 3: Print GetFileName$(DName$) + GetFileExt$(DName$);: Color 15: Print " --> ";: Color 11: Print GetFileName(MovieName$) + GetFileExt(MovieName$)
Color 15: Print: Print "DONE !": Print
Print
If UseExisting Then
    Shell SystemOpen$ + " . > " + NULL$ + " 2>&1"
Else
    Shell SystemOpen$ + " .. > " + NULL$ + " 2>&1"
    If Wipe_TMP_Files Then
        ChDir ".."
        RmDir "frames"
    End If
End If
System

Sub CheckProjectSubDirs
    PopDir$ = _CWD$
    ChDir ProjectHome$
    ChkD$ = "GRAYSCALE"
    GoSub Chkit
    ChkD$ = "4BPP"
    GoSub Chkit
    ChkD$ = "8BPP"
    GoSub Chkit
    ChkD$ = "BITMAP"
    GoSub Chkit
    ChkD$ = "BITMAP" + Slash$ + "1BPP"
    GoSub Chkit
    ChkD$ = "BITMAP" + Slash$ + "2BPP"
    GoSub Chkit
    ChkD$ = "BITMAP" + Slash$ + "4BPP"
    GoSub Chkit
    ChkD$ = "BITMAP" + Slash$ + "8BPP"
    GoSub Chkit
    ChDir PopDir$
    Exit Sub
    Chkit:
    If _DirExists(ChkD$) Then
    Else
        MkDir ChkD$
    End If
    Return
End Sub


Function GetUserChoice% ()
    SetMyScreen 550, 300
    _Title "X16 Movie Maker"
    _ScreenShow
    _Dest 0
    Color 14, 1
    Cls
    ShowLogo
    Locate 11, 5: Color 7
    Print "Select ";: Color 14: Print "YES";: Color 7
    Print " to open a video file for conversion!"

    Locate 13, 5: Color 7
    Print "Select ";: Color 14: Print "NO";: Color 7
    Print " to process already extracted frames !"

    X = _MessageBox("New Video Project", "Open a Video File " + Chr$(13) + "To Create a New X16 Video ?", "yesnocancel", "question", 1)
    If X = 0 Then System
    GetUserChoice = X
End Function

Sub FFMpeg_ExtractFrames
    SetMyScreen 800, 500
    _Title "X16 Movie Maker - FFMPEG Processing"
    DName$ = GetFileName(TName$) + GetFileExt(TName$)
    If InStr(1, TName$, Chr$(32)) > 0 Then
        TName$ = Chr$(34) + TName$ + Chr$(34)
    End If
    CMD$ = "ffmpeg  -i " + TName$ + " -vf fps=" + MovieFPS$ + "/1 -c:v png frames/%08d.png"
    _Dest _Console
    Cls
    Print
    Print "EXTRACTING FRAMES": Print
    Print CMD$: Print
    _Dest 0
    Color 15, 1
    Cls
    For I = 1 To 8: Print: Next
    ShowLogo
    Color 14
    Print "EXTRACTING FRAMES": Print
    Color 15
    Print Left$(CMD$, 6);
    Color 7
    Print Mid$(CMD$, 7)
    Print
    Shell _DontWait _Hide CMD$
    MonitorFrames ".png"
    _Dest 0
    Print
    Color 14
    DualPrint "PREPARING TO EXTRACT AUDIO"
    _Dest 0
    Color 7
    DualPrint " (8 bit, monoaural)"
    DualPrint ""
    _Dest 0
    Print
    defaultsr$ = "17930"
    dorateagain:
    AudioRate$ = _InputBox$("Audio Sample Rate", "Enter Desired Sample Rate.", defaultsr$)

    If AudioRate$ = "" Then
        If I_WantToQuit Then System
    End If

    If AudioRate$ = "" Then GoTo dorateagain
    If IsNum(AudioRate$) Then
        ar = Val(AudioRate$)
        If ar < 8000 Or ar > 44100 Then GoSub rateerror: GoTo dorateagain
        ar = PADRATE(ar)
        MovieSeconds = FrameCount / Val(MovieFPS$)
        alength = ar * MovieSeconds
        aframe = alength / FrameCount
        If aframe > 3096 Then
            _MessageBox "AUDIO TO LARGE", "Audio Frame to large must be less than 3096" + Chr$(13) + "Current is: " + Str$(aframe)
            GoTo dorateagain
        End If
    Else
        GoSub rateerror
        GoTo dorateagain
    End If

    AudioRate$ = Str$(ar)
    _MessageBox "ADJUSTED RATE", "Adjusted Audio Rate: " + AudioRate$ + Chr$(13) + "Audio Frame: " + Str$(aframe), "info"
    CMD$ = "ffmpeg -i " + TName$ + " -f s8 -acodec pcm_s8 -ac 1  -ar " + AudioRate$ + " audio.out"
    DualPrint CMD$
    DualPrint ""
    _Dest _Console
    Shell CMD$
    _Dest 0
    Cls
    Exit Sub
    rateerror:
    _MessageBox "INPUT ERROR", "Audio Rate must be between 8000 & 32000 !" + Chr$(13) + "TRY AGAIN", "info"
    Return
End Sub

Function VPAL_AVERAGE% (PEntry As VPALTYPE)
    G% = _ShR(PEntry.GB, 4)
    B% = PEntry.GB And &H0F
    VPAL_AVERAGE = (G% + B% + PEntry.R) / 3
End Function

Function VERA_RATEBYTE% (SampleRate)
    VERA_RATEBYTE = _Round((SampleRate / 48828.15) * 128)
End Function

Function PADRATE (SampleRate)
    TMPRATE = SampleRate
    TMP1 = VERA_RATEBYTE(TMPRATE)
    Do
        TMPRATE = TMPRATE + 2
        TMP2 = VERA_RATEBYTE(TMPRATE)
    Loop Until TMP2 > TMP1
    Do
        TMPRATE = TMPRATE - 1
        TMP2 = VERA_RATEBYTE(TMPRATE)
    Loop Until TMP1 = TMP2
    If (SampleRate + 50) > TMPRATE Then
        PADRATE = SampleRate
    Else
        PADRATE = TMPRATE - 50
    End If
End Function


Sub CheckForFrames
    _Title "X16 Movie Maker - Counting Frames"
    frm1suff$ = "00000001"
    Ext$ = ".png"
    cfile$ = frm1suff$ + Ext$
    If _FileExists(cfile$) Then GoTo getCount
    Ext$ = ".bmp"
    cfile$ = frm1suff$ + Ext$
    If _FileExists(cfile$) Then GoTo getCount
    Ext$ = ".jpg"
    cfile$ = frm1suff$ + Ext$
    If _FileExists(cfile$) Then GoTo getCount
    Ext$ = ".jpeg"
    cfile$ = frm1suff$ + Ext$
    If _FileExists(cfile$) Then GoTo getCount
    FrameCount = 0
    FrameExt$ = "NOT FOUND"
    Exit Sub
    getCount:
    CountFrames Ext$
    If FrameCount > 0 Then FrameExt$ = Ext$
End Sub

Sub SetUpMovieParameters
    Static ParamsSet
    If ParamsSet Then Exit Sub
    ResolutionMenu
    If FormatChoice = 10 Then
        GoTo STARTCONVERSION
    End If
    If FormatChoice = 9 Then
        getfreehand
    Else
        VideoHeader.HINT = MovieChoice(FormatChoice).HINT
        _Dest _Console
        Print
        Print ImageWidth
        Print ImageHeight
        Print VideoHeader.HINT
        Print
        GoTo STARTCONVERSION
    End If

    skipres:
    SetSpriteSizes
    UseDither = DoDithering
    NO_PALETTE_SHIFTING = -1
    GetColCount
    Make4BPP = Val(UsedCols$) < 17
    If Val(UsedCols$) < 250 And (Not Make4BPP) Then
        NO_PALETTE_SHIFTING = Not DoPalShift
    End If
    STARTCONVERSION:
    _Dest _Console
    If Bit_Map_Mode Then
        Print "Creating BITMAP based video. "
    End If
    If Make4BPP Then
        Print "Using 4 Bits per Pixel Mode."
    End If
    _Dest 0
    VideoHeader.FrameWidth = ImageWidth
    VideoHeader.FrameHeight = ImageHeight
    VideoHeader.SpriteWidth = SprWidth
    VideoHeader.SpriteHeight = SprHeight
    Palsize = 512
    ReDim Sprite(0 To (((SprWidth * SprHeight)) - 1)) As _Unsigned _Byte
    If Make4BPP Then ReDim Sprite4BPP(0 To (((SprWidth * SprHeight) / 2) - 1)) As _Unsigned _Byte
    UsingPalette = -1
    If FormatChoice = 9 Then MovieFPS$ = SetFrameRate
    VideoHeader.FPS = Val(MovieFPS$)
    ParamsSet = -1
End Sub

Function Get_WipeOutChoice
    tmp = _MessageBox("Delete Frame Files", "Remove ALL frame Images when conversion finished ?" + Chr$(13) + "(They Take A LOT of space)", "yesno", "question", 1)
    Get_WipeOutChoice = (tmp = 1)
End Function

Sub getfreehand
    SetMyScreen 800, 700
    startfreehandover:
    Color 15, 1: Cls
    ShowLogo
    View Print 7 To 34
    Print
    Color 2
    Tprint " {GRAY 1}You are about to enter desired {WHT} Video resolution {YEL}free hand{GRN}.{13}"
    Tprint " {GRAY 1}There is {WHT}some error feedback but not much{GRN}.{13}"
    Print
    Color 7
    Print "  Your Video ";: Color 15
    Print "IS NOT";: Color 7
    Print " guaranteed to play ";: Color 15:
    Print "properly !"
    Print
    Color 14
    Tprint "{LIGHT GREEN}Width {WHT}MUST {GRAY 1}be an even multiple of {YEL}16 {GRN}!{13}"
    Tprint "{LIGHT GRN}Height{WHT} MUST {GRAY 1}be an even multiple of {YEL}8 {GRN}!{13}"
    Color 15
    Tprint "{WHT}Good Luck {GRN}!{13}"
    Print
    Tprint "{WHT}READY{GRN}.{WHT}{13}"
    Print
    getxres:
    Tprint "{GRAY 1}Enter {LIGHT GRN}Frame Width {ORG}({YEL}X Resolution{ORG}){LIGHT GREEN}"
    Input X
    If IsValidXRes(X) Then
        ImageWidth = X
    Else
        Print: Beep
        Tprint "{LIGHT GREEN}" + Str$(X) + " {GRAY 1}is not a valid Frame Width.   {ORG}({YEL}see user guide{ORG}){WHT}{13}"
        Print
        GoTo getxres
    End If
    getyres:
    Tprint "{GRAY 1}Frame Width is{GRN}:{YEL}" + Str$(ImageWidth) + "{GRAY 1}{13}"
    Tprint "{GRAY 1}Enter {LIGHT GRN}Frame Height {ORG}({YEL}Y Resolution{ORG}){LIGHT GREEN}"
    Input Y
    If IsValidYRes(Y) Then
        ImageHeight = Y
    Else
        Print: Beep
        Tprint "{LIGHT GREEN}" + Str$(Y) + " {GRAY 1}is not a valid Frame Height.   {ORG}({YEL}see user guide{ORG}){WHT}{13}"
        Print
        GoTo getyres
    End If
    View Print
End Sub

Sub SAVESAMPLEBIN (SCOUNT As _Unsigned Long)
    F$ = ".." + Slash$ + "FRAME" + _Trim$(Str$(SCOUNT)) + ".bin"
    F2$ = ".." + Slash$ + "FRAMEX" + _Trim$(Str$(SCOUNT)) + ".bin"
    P$ = ".." + Slash$ + "FRAMEX" + _Trim$(Str$(SCOUNT)) + ".pal.bin"

    Open F$ For Binary As #8
    Put #8, , ImageData()
    Close 8
    Open F2$ For Binary As #8
    Put #8, , ImageDataX_BPP()
    Close 8
    Open P$ For Binary As #8
    Put #8, , VERAPALX_BPP()
    Close 8
End Sub

Sub SetSpriteSizes
    If ImageWidth Mod 64 = 0 Then SprWidth = 64: GoTo SetSprHeight
    If ImageWidth Mod 32 = 0 Then SprWidth = 32: GoTo SetSprHeight
    SprWidth = 16
    SetSprHeight:
    If ImageHeight Mod 64 = 0 Then SprHeight = 64: Exit Sub
    If ImageHeight Mod 32 = 0 Then SprHeight = 32: Exit Sub
    If ImageHeight Mod 16 = 0 Then SprHeight = 16: Exit Sub
    SprHeight = 8
End Sub

Sub SetBitMapMode
    Dim bitdivisor As Integer
    VideoHeader.VTYPE = 3
    VideoHeader.BPP = X_BITS
    Rat = ImageWidth / ImageWidth
    Select Case X_BITS
        Case 1
            UsedCols$ = "2"
        Case 2
            UsedCols$ = "4"
        Case 4
            UsedCols$ = "16"
    End Select
    MovieFPS$ = GetDefaultFRM_Rate

    PalNum = Val(UsedCols$) - 1
    Select Case X_BITS
        Case 1
            bitdivisor = 8
        Case 2
            bitdivisor = 4
        Case 4
            bitdivisor = 2
        Case 8
            bitdivisor = 1
        Case Else
            ErrorHalt "Error Setting Image Buffer.  Invalid Bitdepth: " + Str$(bits)
    End Select
    sizex_bpp = ((ImageHeight * ImageWidth) / bitdivisor)

    Msg$ = "X Bits: " + Str$(X_BITS) + Chr$(13)
    Msg$ = Msg$ + "Size Buffer: " + Str$(sizex_bpp) + Chr$(13)


    _MessageBox "BITMAP MODE", Msg$, "INFO"

    ReDim ImageData(0 To ((ImageHeight * ImageWidth) - 1))
    ReDim ImageDataX_BPP(0 To (sizex_bpp - 1))
    ReDim VERAPALX_BPP(0 To PalNum) As VPALTYPE
End Sub

Sub DownSampleImage
    Dim bitdivisor As Integer
    Dim shifter As Integer
    Dim shift_step As Integer
    Dim Bt As _Unsigned _Byte

    PalNum = Val(UsedCols$) - 1
    Select Case X_BITS
        Case 1
            shifter = 7
            shift_step = -1
        Case 2
            shifter = 6
            shift_step = -2
        Case 4
            shifter = 4
            shift_step = -4
        Case Else
            ErrorHalt "Error Converting Image Buffer.  Invalid Bitdepth: " + Str$(bits)
    End Select

    ImgIndx = 0
    For X_Indx = 0 To (sizex_bpp - 1)
        ImageDataX_BPP(X_Indx) = 0
        For I = shifter To 0 Step shift_step
            ImageDataX_BPP(X_Indx) = ImageDataX_BPP(X_Indx) Or (_ShL(ImageData(ImgIndx), I))
            ImgIndx = ImgIndx + 1
        Next
    Next
    For I = 0 To PalNum
        VERAPALX_BPP(I) = VERAPAL(I)
    Next
End Sub


Function IsValidXRes (x%)
    IsValidXRes = (x% > 32) And (x% < 321) And (x% Mod 16) = 0
End Function

Function IsValidYRes (y%)
    IsValidYRes = (y% > 15) And (y% < 481) And (y% Mod 8) = 0
End Function

Sub ShowSplash
    DONE = 0
    _ScreenHide
    _Title "X16 Movie Maker"
    Image& = _LoadImage(_Embedded$("splashimg"), , "MEMORY")
    Screen Image&
    _ScreenShow
    If Timer > 86395 Then
        TIMETARG = 5
    Else
        TIMETARG = Timer + 6
    End If
    Do
        _Limit 60
        X$ = InKey$
        If Timer > TIMETARG And Timer < 86395 Then DONE = -1
        If X$ = Chr$(27) Or X$ = Chr$(32) Or X$ = Chr$(13) Then DONE = -1
    Loop Until DONE
    _ScreenHide
    Screen 7
    _FreeImage Image&
End Sub

Function DoDithering% ()
    DitheringMessage
    tmp = _MessageBox("DITHERING", "Do you want to use Floyd Steinberg dithering ?", "yesno", "question", 0)
    DoDithering = (tmp = 1)
End Function

Function DoPalShift ()
    DitheringMessage
    tmp = _MessageBox("Palette SHIFTING", "Enable Palette Shifting  ?" + Chr$(13) + "(See VIDEO-PALETTES.TXT)", "yesno", "question", 0)
    DoPalShift = (tmp = 1)
End Function

Function I_WantToQuit
    tmp = _MessageBox("Exit X16 Movie Maker", "Do You really want to EXIT  ?", "yesno", "question", 0)
    I_WantToQuit = (tmp = 1)
End Function

Function SetFrameRate$ ()
    default$ = GetDefaultFRM_Rate
    FrameRateMessage
    getframes:
    tmp$ = _InputBox$("Set Frame Rate", "Enter desired FPS:", default$)
    If tmp$ = "" Then If I_WantToQuit Then System
    If tmp$ = "" Then GoTo getframes
    If IsNum(tmp$) And Val(tmp$) < 31 And Val(tmp$) > 3 Then
        SetFrameRate = tmp$
        Exit Function
    End If
    _MessageBox "Invalid Input", tmp$ + " is an invalid input" + Chr$(13) + "Try Again", "warning"
    GoTo getframes
End Function

Function GetDefaultFRM_Rate$
    default = 15
    adjuster = 1
    If Make4BPP Then adjuster = .5
    If Bit_Map_Mode Then
        Select Case X_BITS
            Case 4
                adjuster = .5
            Case 2
                adjuster = .25
            Case 1
                adjuster = .125
        End Select
    End If
    tryagain:
    TestBuffRate = default * ImageHeight * ImageWidth * adjuster
    If TestBuffRate > 180000 Then
        default = default - 1
        GoTo tryagain
    End If
    GetDefaultFRM_Rate$ = _Trim$(Str$(default))
End Function


Sub DitheringMessage
    SetMyScreen 750, 370
    _Title "X16 Movie Maker - DITHERING"
    _Dest 0
    Color 15, 1
    Cls
    Color 7
    For I = 1 To 8: Print: Next
    ShowLogo
    Color 7
    Print " X16 Movie Maker can use:";
    Color 2
    Print Chr$(34);
    Color 14
    Print " Floyd Steinberg dithering";
    Color 2
    Print Chr$(34);
    Print

    Color 7
    Print " This ";

    Color 14: Print "can ";
    Color 7
    Print "improve color appearance."
    Print
    Print " But may look worse on Videos with  ";

    Color 10: Print "few colors.";
    Print
    Print
    Color 7
    Print " (";
    Color 14
    Print "see user guide";
    Color 7
    Print ")"
End Sub

Sub ColorChoiceMessage
    SetMyScreen 750, 460
    _Title "X16 Movie Maker - Color & Bit Depth"
    _Dest 0
    Color 15, 1
    Cls
    Color 7
    For I = 1 To 9: Print: Next
    ShowLogo
    Tprint " {GRAY 1}Here is where you chose how many colors{WHT} X16 Movie Maker{GRAY 1}{13}  will use.{13}{13}"
    Tprint " {GRAY 1}Valid Entrys are the word{WHT} GRAY {GRAY 1} or a {YEL} NUMBER {GRAY 1}({WHT}16{GRN}-{WHT}256{GRAY 1}).{13}{13}"
    Tprint " {GRAY 1}Choosing {WHT}16{GRAY 1} colors. {WHT}OR {GRAY 1} entering the word{GRN}: {WHT}GRAY{GRAY 1} enables{13} {YEL}4{LIGHT GREEN}bpp {GRAY 1} mode."
End Sub

Sub FrameRateMessage
    SetMyScreen 800, 525
    _Title "X16 Movie Maker - Set Frame Rate"
    _Dest 0
    Color 15, 1
    Cls
    Color 7
    For I = 1 To 8: Print: Next
    ShowLogo
    Tprint " {WHT}X16 Movie Maker{GRAY 1} will let you set{YEL} any possible Frame rate{GRAY 1} up to {LIGHT GREEN}30{YEL} fps{13}"
    Tprint " {GRAY 1}This does not mean the {WHT}Commander X16{YEL} can play{GRAY 1} that{LIGHT GREEN} Frame Rate.{13}{13}{13}"
    Tprint "{LIGHT GREEN} The Convertor assumes some {YEL}Homework{LIGHT GREEN} on the part of the User!{13}"
    Tprint "{13}{13}{GRAY 1} Recommended Frame Rates are in the range of {WHT}5 {GRAY 1}to {WHT}15 {YEL}fps{GRN}.{13}{13}"
    Tprint " {GRAY 1}({YEL}see user guide{GRAY 1}){13}"
End Sub


Sub ResolutionMenu
    Make4BPP = 0
    GrayScaleVideo = 0
    UseDither = -1
    ColorChoice = 1
    NO_PALETTE_SHIFTING = 0
    UserChoice = 1
    SetMyScreen 800, 800
    StartPMenu:
    _Title "X16 Movie Maker - Video Parameters (sprite mode)"
    _Font 16
    _Blink Off
    Color 15, 1: Cls
    ShowLogo
    Locate 10, 1
    Tprint "{WHT}         Standard 1{13}"
    Tprint "{RED}         ----------{13}"
    Tprint "  {YEL}         Normal Resolution{GRN}:{LIGHT GREEN} 160{GRN}x{LIGHT GRN}112   {LIGHT CYAN} ..."

    GoSub SPACEIT

    Tprint "{WHT}         Standard 2" + Chr$(13)
    Tprint "{RED}         ----------" + Chr$(13)
    Tprint "  {YEL}         Normal Resolution{GRN}:{LIGHT GREEN} 192{GRN}x{LIGHT GRN}128   {LIGHT CYAN} ..."


    GoSub SPACEIT


    Tprint "{WHT}         Standard 3" + Chr$(13)
    Tprint "{RED}         ----------" + Chr$(13)
    Tprint "  {YEL}         Tall Resolution{GRN}:{LIGHT GREEN}   96{GRN}x{LIGHT GRN}160   {LIGHT CYAN}  ...{13}"
    Tprint "      {GRAY 1}     ({ORG}Source Video{YEL}:{LIGHT BLUE} TikTok, Youtube Short, Cell Phone{GRAY 1})"

    GoSub SPACEIT

    Tprint "{WHT}         Standard 4" + Chr$(13)
    Tprint "{RED}         ----------" + Chr$(13)
    Tprint "  {YEL}         Tall Resolution{GRN}:{LIGHT GREEN}   80{GRN}x{LIGHT GRN}144    {LIGHT CYAN} ...{13}"
    Tprint "  {GRAY 1}         ({ORG}Source Video{YEL}:{LIGHT BLUE} TikTok, Youtube Short, Cell Phone{GRAY 1})"

    GoSub SPACEIT
    Print

    Tprint "                        {YEL}Vertically Compressed Resolutions{13}"
    Tprint "                 {GRAY 2}({CYAN}Vertical resolution to be scaled up on Playback{GRAY 2}){13}"
    Tprint "                {RED}---------------------------------------------------{13}"


    Tprint "          {YEL}  Compressed {GRN} #{LIGHT GREEN}1{GRN}:{LIGHT GREEN}  320{GRN}x{LIGHT GRN}112     {LIGHT CYAN}...{13}"
    Print
    Tprint "  {YEL}          Compressed {GRN} #{LIGHT GREEN}2{GRN}:{LIGHT GREEN}  320{GRN}x{LIGHT GRN}88      {LIGHT CYAN}...{13}"
    Print
    Tprint "  {YEL}          Compressed {GRN} #{LIGHT GREEN}3{GRN}:{LIGHT GREEN}  224{GRN}x{LIGHT GRN}112     {LIGHT CYAN}...{13}"
    Print
    Tprint "  {YEL}          Compressed {GRN} #{LIGHT GREEN}4{GRN}:{LIGHT GREEN}  224{GRN}x{LIGHT GRN}96      {LIGHT CYAN}...{13}"

    GoSub SPACEIT
    Tprint "       {WHT} CUSTOM RESOLUTION:{13}"
    Tprint "          {RED}{34}{LIGHT BLUE}Expert Mode{RED}{34}"
    Locate 43, 14: Color 1, 0
    Tprint "{GRAY 1} Use this option at your {RED}OWN RISK{YEL} !                     "
    Locate 44, 14
    Tprint "{LIGHT GREEN} [{YEL}SOME{LIGHT GREEN}] {GRN} error checking is done.                        "
    Locate 45, 14
    Tprint "{GRN} But not all choices will result in a {RED}{34}{YEL}playable{RED}{34}{GRN} video. "
    Color 15, 1
    Locate 48, 2: Tprint " {WHT}Source Video{YEL}: {LIGHT GREEN}"
    Color 15, 0
    Tprint Left$(DName$, 160)
    Rem Locate 50, 2: Print _Trim$(Str$(Len(DName$)));



    GoSub SHOWCHOICE
    Got_A_Choice = 0

    Do
        C = _KeyHit

        Select Case C
            Case 49 To 57
                UserChoice = C - 48
                GoSub CLEARLAST
                GoSub SHOWCHOICE
            Case 18432, 19200
                LastChoice = UserChoice
                If UserChoice = 1 Then
                    UserChoice = 9
                Else
                    UserChoice = UserChoice - 1
                    If LastChoice = 5 Then ColorChoice = LastColorChoice
                End If
                If UserChoice = 5 Then
                    LastColorChoice = ColorChoice
                    ColorChoice = 5
                    If GrayScaleVideo Then ColorChoice = 6
                End If
                GoSub CLEARLAST
                GoSub SHOWCHOICE
            Case 20480, 19712
                LastChoice = UserChoice
                If UserChoice = 9 Then
                    UserChoice = 1
                Else
                    UserChoice = UserChoice + 1
                    If LastChoice = 5 Then ColorChoice = LastColorChoice
                End If
                If UserChoice = 5 Then
                    LastColorChoice = ColorChoice
                    ColorChoice = 5
                    If GrayScaleVideo Then ColorChoice = 6
                End If
                GoSub CLEARLAST
                GoSub SHOWCHOICE
            Case 15616
                If UserChoice = 9 Then
                    Beep
                    GoTo SkipCase15616
                End If
                If UseDither Then
                    UseDither = 0
                Else
                    UseDither = -1
                End If
                GoSub SHOWCHOICE
                SkipCase15616:
            Case 17408
                GoSub SaveSettings
                BitMapResolutionMenu
                If ReturnChoice = 27 Then
                    GoSub RestoreSettings
                    GoTo StartPMenu
                End If
                FormatChoice = 10
                Got_A_Choice = -1
            Case 15104
                FormatChoice = UserChoice
                Got_A_Choice = -1

            Case 15872
                If UserChoice = 9 Then Beep: GoTo donecolorchoice
                ColorChoice = ColorChoice + 1

                If ColorChoice = 4 Then ColorChoice = 5
                If UserChoice = 5 Then
                    If ColorChoice = 7 Then ColorChoice = 5
                End If
                If ColorChoice = 7 Then ColorChoice = 1
                donecolorchoice:
                GoSub SHOWCHOICE

            Case 16128
                If UserChoice = 5 Or UserChoice = 9 Then
                    Beep
                Else
                    ColorChoice = 4
                    ColSkipper = 0
                End If
                GoSub SHOWCHOICE
            Case 27
                If I_WantToQuit Then System
        End Select
    Loop Until Got_A_Choice
    Exit Sub



    SHOWCHOICE:
    _Blink Off

    Color 4, 1
    Locate 4, 55: Tprint "{RED}{213}" + String$(40, 205) + "{184}"
    Locate 5, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 6, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 7, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 8, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 9, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 10, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 11, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 12, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 13, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 14, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 15, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 16, 55: Tprint "{RED}{179}" + String$(40, 32) + "{179}"
    Locate 17, 55: Tprint "{192}" + String$(40, 196) + "{217}"

    Locate 5, 58
    Tprint "{WHT}USE{GRN}: {LIGHT GREEN}{24} {25} {26} {27} {GRAY 1} to make selection.    "

    Locate 6, 59
    Tprint "{LIGHT GREEN}F1{GRN}:{WHT} Do Conversion"

    Locate 14, 60: Tprint "{LIGHT GREEN}F3 {GRN}-{GRAY 1} Toggle Dithering {GRN}({WHT}ON{YEL}/{WHT}OFF{GRN})"
    Locate 15, 60: Tprint "{LIGHT GREEN}F4 {GRN}-{GRAY 1} Change color mode {GRN}({WHT}BPP{GRN})"
    Locate 16, 60: Tprint "{LIGHT GREEN}F5 {GRN}-{YEL} 8{GRN}bpp{GRAY 1} Custom {LIGHT GREEN}#{GRAY 1} of Colors "

    Locate 18, 60: Tprint "{LIGHT GREEN}F10 {GRN}-{YEL} Switch to BitMap Mode"

    Color 6, 0
    Locate 7, 57: Tprint "{ORG}{201}" + String$(36, 205) + "{187}"
    Locate 8, 57: Tprint "{ORG}{186}" + String$(36, 32) + "{186}"
    Locate 9, 57: Tprint "{ORG}{186}" + String$(36, 32) + "{186}"
    Locate 10, 57: Tprint "{ORG}{186}" + String$(36, 32) + "{186}"
    Locate 11, 57: Tprint "{ORG}{186}" + String$(36, 32) + "{186}"
    Locate 12, 57: Tprint "{ORG}{186}" + String$(36, 32) + "{186}"
    Locate 13, 57: Tprint "{ORG}{200}" + String$(36, 205) + "{188}"

    Color 6, 0
    Locate 8, 60

    Select Case UserChoice
        Case 1
            Tprint "{WHT}Standard 1:  {YEL}160{GRN}x{YEL}112"
            Locate 10, 3: Tprint " {YEL}=={RED}>"
            ImageWidth = 160
            ImageHeight = 112
        Case 2
            Tprint "{WHT}Standard 2:  {YEL}192{GRN}x{YEL}128"
            Locate 14, 3: Tprint " {YEL}=={RED}>"
            ImageWidth = 192
            ImageHeight = 128
        Case 3
            Tprint "{WHT}Standard 3:  {YEL}96{GRN}x{YEL}160 {GRAY 2}({LIGHT BLUE}tall{GRAY 2})"
            Locate 18, 3: Tprint " {YEL}=={RED}>"
            ImageWidth = 96
            ImageHeight = 160
        Case 4
            Tprint "{WHT}Standard 4:  {YEL}80{GRN}x{YEL}144 {GRAY 2}({LIGHT BLUE}tall{GRAY 2})"
            Locate 23, 3: Tprint " {YEL}=={RED}>"
            ImageWidth = 80
            ImageHeight = 144
        Case 5
            Tprint "{WHT} Compressed {GRN}#{LIGHT GRN}1{YEL}:  {YEL}320{GRN}x{YEL}112"
            Locate 32, 7: Tprint " {YEL}=={RED}>"
            ImageWidth = 320
            ImageHeight = 112
        Case 6
            Tprint "{WHT} Compressed {GRN}#{LIGHT GRN}2{YEL}:  {YEL}320{GRN}x{YEL}88"
            Locate 34, 7: Tprint " {YEL}=={RED}>"
            ImageWidth = 320
            ImageHeight = 88
        Case 7
            Tprint "{WHT} Compressed {GRN}#{LIGHT GREEN}3{YEL}:  {YEL}224{GRN}x{YEL}112"
            Locate 36, 7: Tprint " {YEL}=={RED}>"
            ImageWidth = 224
            ImageHeight = 112
        Case 8
            Tprint "{WHT} Compressed {GRN}#{LIGHT GREEN}4{YEL}:  {YEL}224{GRN}x{YEL}96"
            Locate 38, 7: Tprint " {YEL}=={RED}>"
            ImageWidth = 224
            ImageHeight = 96
        Case 9
            Tprint "{WHT} EXPERT M{GRAY 1}ode {LIGHT GREEN} !"
            Locate 41, 3: Tprint " {YEL}=={RED}>"
    End Select
    ColorParse:
    If UserChoice = 9 Then GoTo SkipTheColorStuff
    Select Case ColorChoice
        Case 1
            Make4BPP = 0
            GrayScaleVideo = 0
            UsedCols$ = "256"
            NO_PALETTE_SHIFTING = -1
        Case 2
            Make4BPP = 0
            GrayScaleVideo = 0
            UsedCols$ = "240"
            NO_PALETTE_SHIFTING = 0
        Case 3
            Make4BPP = 0
            GrayScaleVideo = 0
            UsedCols$ = "224"
            NO_PALETTE_SHIFTING = 0
        Case 4
            Make4BPP = 0
            GrayScaleVideo = 0
            NO_PALETTE_SHIFTING = -1
            If ColSkipper Then GoTo SkipColAdjust
            GetColCnt:
            UsedCols$ = "224"
            MSG$ = "Enter # of Palette colors to Use. (16-256)"
            X$ = _InputBox$("How Many Colors", MSG$, UsedCols$)
            X$ = Left$(_Trim$(UCase$(X$)), 4)
            If X$ = "GRAY" Or X$ = "GREY" Then
                ColorChoice = 6
                GoTo ColorParse
            End If
            If Not IsNum(X$) Then
                _MessageBox "INVALID INPUT", "TRY AGAIN", "error"
                GoTo GetColCnt
            End If
            C% = Val(X$)
            If C% < 16 Or C% > 256 Then
                _MessageBox "INVALID INPUT", "TRY AGAIN", "error"
                GoTo GetColCnt
            End If
            LastCol$ = UsedCols$
            UsedCols$ = X$
            SkipColAdjust:
            If Val(UsedCols$) < 17 Then ColorChoice = 5: GoTo ColorParse
            ColSkipper = -1
        Case 5
            Make4BPP = -1
            GrayScaleVideo = 0
            UsedCols$ = "16"
        Case 6
            Make4BPP = -1
            GrayScaleVideo = -1
            UsedCols$ = "16"
    End Select
    SkipTheColorStuff:


    SetSpriteSizes
    MovieFPS$ = GetDefaultFRM_Rate$
    Locate 10, 60: Print String$(20, 32);
    Locate 10, 60: Tprint "{WHT} FPS: {LIGHT GREEN}"
    If UserChoice < 9 Then Print MovieFPS$; "   "; Else Tprint "{GRN}({YELLOW}tbd{GRN})"
    Tprint "{WHT}  BPP: {LIGHT GREEN}"

    If UserChoice < 9 Then
        If Make4BPP Then
            Print "4";
        Else
            Tprint "8  {WHT}#{GRAY 1}Colors{GRN}: {LIGHT GREEN}" + UsedCols$
        End If
    Else
        Tprint "{GRN}({YELLOW}tbd{GRN})"
    End If
    Locate 11, 73

    If GrayScaleVideo And Not (UserChoice = 9) Then
        Tprint "{GRAY 2}GrayScale"
    Else
        Tprint "         "
    End If
    Locate 12, 60: Tprint "{WHT} Dithering: {YEL}"
    If UserChoice = 9 Then
        Tprint "{GRN}({YELLOW}tbd{GRN})"
    Else
        If UseDither Then
            Print "ON   ";
        Else
            Print "OFF  ";
        End If
    End If
    If Not Make4BPP Then
        Tprint "{WHT} Pal Shift{GRN}: {YEL}"
        If UserChoice = 9 Then
            Tprint "{GRN}({YELLOW}tbd{GRN})"
        Else
            If NO_PALETTE_SHIFTING Then
                Print "OFF ";
            Else
                Print "ON  ";
            End If
        End If
    End If
    Return

    CLEARLAST:
    Select Case LastChoice
        Case 1
            Locate 10, 3
        Case 2
            Locate 14, 3
        Case 3
            Locate 18, 3
        Case 4
            Locate 23, 3
        Case 5
            Locate 32, 7
        Case 6
            Locate 34, 7
        Case 7
            Locate 36, 7
        Case 8
            Locate 38, 7
        Case 9
            Locate 41, 3
    End Select
    Color 15, 1
    Print String$(4, 32);
    Return

    SPACEIT:
    Print: Print
    Return

    SaveSettings:
    SaveWidth = ImageWidth
    SaveHeight = ImageHeight
    SaveChoice = UserChoice
    SaveColor = ColorChoice
    SaveLast = LastChoice
    SaveGray = GrayScaleVideo
    SaveDither = UseDither
    Return

    RestoreSettings:
    ImageWidth = SaveWidth
    ImageHeight = SaveHeight
    UserChoice = SaveChoice
    GrayScaleVideo = SaveGray
    ColorChoice = SaveColor
    LastChoice = SaveLast
    UseDither = SaveDither
    Return

End Sub

Sub BitMapResolutionMenu
    Const BW_MODE = 0
    Const GRAY_MODE = 1
    Const GREEN_MODE = 2
    Const AMBER_MODE = 3
    Const COLOR_MODE = 32

    Static Activated
    Static SaveWidth
    Static SaveHeight
    Static SaveChoice
    Static SaveLast
    Static SaveGray
    Static SaveDither
    Static SaveBits
    Static SavePalChoice

    If Activated = 0 Then
        Make4BPP = 0
        GrayScaleVideo = -1
        UseDither = -1
        ColorChoice = 1
        NO_PALETTE_SHIFTING = -1
        Bit_Map_Mode = -1
        X_BITS = 1
        LAST_BITS = 0
        Activated = -1
        BitMapChoice = 1
        PalChoice = 0
    Else
        GoSub RestoreSettings
    End If

    Rem SetMyScreen 800, 800
    Cls 0
    _Title "X16 Movie Maker - Video Parameters (bitmap mode)"
    _Font 16
    _Blink Off
    Color 15, 1: Cls
    ShowLogo
    Locate 10, 1
    Tprint "{WHT}         BitMap  1{13}"
    Tprint "{RED}         ---------{13}"
    Tprint "  {YEL}         Normal Resolution{GRN}: {LIGHT GREEN} 320{GRN}x{LIGHT GRN}240    {LIGHT CYAN} ..."

    GoSub SPACEIT

    Tprint "{WHT}         BitMap 2{13}"
    Tprint "{RED}         --------{13}"
    Tprint "  {YEL}           High Resolution{GRN}: {LIGHT GREEN} 640{GRN}x{LIGHT GRN}480    {LIGHT CYAN} ...{13}"
    Tprint "  {GRAY 1}            ({LIGHT GREEN}1 {YEL}bpp  {LIGHT GREEN} ONLY {GRN}!!{GRAY 1})"

    GoSub SPACEIT

    Tprint "{WHT}         BitMap 3" + Chr$(13)
    Tprint "{RED}         --------" + Chr$(13)
    Tprint "  {YEL}            Compressed Low{GRN}:{LIGHT GREEN}  320{GRN}x{LIGHT GRN}120   {LIGHT CYAN}  ...{13}"

    GoSub SPACEIT

    Tprint "{WHT}         BitMap 4" + Chr$(13)
    Tprint "{RED}         --------" + Chr$(13)
    Tprint "  {YEL}         Compressed High 1{GRN}:{LIGHT GREEN}  640{GRN}x{LIGHT GRN}120   {LIGHT CYAN}  ...{13}"

    GoSub SPACEIT

    Tprint "{WHT}         BitMap 5" + Chr$(13)
    Tprint "{RED}         --------" + Chr$(13)
    Tprint "  {YEL}         Compressed High 2{GRN}:{LIGHT GREEN}  640{GRN}x{LIGHT GRN}140   {LIGHT CYAN}  ...{13}"

    GoSub SPACEIT
    Print
    Tprint "       {WHT} CUSTOM RESOLUTION:{13}"
    Tprint "          {RED}{34}{LIGHT BLUE}BitMap Expert Mode{RED}{34}"
    Locate 37, 14: Color 1, 0
    Tprint "{GRAY 1} Use this option at your {RED}OWN RISK{YEL} !                     "
    Locate 38, 14
    Tprint "{LIGHT GREEN} [{YEL}SOME{LIGHT GREEN}] {GRN} error checking is done.                        "
    Locate 39, 14
    Tprint "{GRN} But not all choices will result in a {RED}{34}{YEL}playable{RED}{34}{GRN} video. "
    Color 15, 1
    Locate 47, 2: Tprint " {WHT}Source Video{YEL}: {LIGHT GREEN}"
    Color 15, 0
    Tprint Left$(DName$, 160)


    GoSub SHOWCHOICE
    Got_A_Choice = 0


    Do
        C = _KeyHit

        Select Case C
            Case 18432, 19200
                LastChoice = BitMapChoice
                If BitMapChoice = 1 Then
                    BitMapChoice = 6
                Else
                    BitMapChoice = BitMapChoice - 1
                End If
                If BitMapChoice = 2 Then GoSub SaveColorOnly
                If LastChoice = 2 Then GoSub RestoreColorOnly
                GoSub CLEARLAST
                GoSub SHOWCHOICE

            Case 20480, 19712
                LastChoice = BitMapChoice
                If BitMapChoice = 6 Then
                    BitMapChoice = 1
                Else
                    BitMapChoice = BitMapChoice + 1
                End If
                If BitMapChoice = 2 Then GoSub SaveColorOnly
                If LastChoice = 2 Then GoSub RestoreColorOnly
                GoSub CLEARLAST
                GoSub SHOWCHOICE

            Case 15616
                If UseDither Then
                    UseDither = 0
                Else
                    UseDither = -1
                End If
                GoSub SHOWCHOICE

            Case 15104
                ReturnChoice = 10
                X_PALMODE = PalChoice
                SetBitMapMode
                Exit Sub

            Case 17408
                Bit_Map_Mode = 0
                ReturnChoice = 27
                GoSub SaveSettings
                Exit Sub

            Case 15872
                LASTBITS = X_BITS
                Select Case X_BITS
                    Case 1
                        X_BITS = 2
                        UsedCols$ = "4"
                    Case 2
                        X_BITS = 4
                        UsedCols$ = "16"
                    Case 4
                        X_BITS = 1
                        UsedCols$ = "2"
                End Select
                GoSub SHOWCHOICE

            Case 16128
                Select Case PalChoice
                    Case BW_MODE, GRAY_MODE, GREEN_MODE, AMBER_MODE
                        If X_BITS <> 1 And PalChoice = BW_MODE Then
                            PalChoice = GREEN_MODE
                        Else
                            PalChoice = PalChoice + 1
                        End If
                        If PalChoice = 4 Then PalChoice = COLOR_MODE
                    Case COLOR_MODE
                        PalChoice = BW_MODE
                End Select
                If PalChoice < COLOR_MODE Then GrayScaleVideo = -1 Else GrayScaleVideo = 0
                GoSub SHOWCHOICE

            Case 27
                If I_WantToQuit Then System

        End Select
    Loop Until Got_A_Choice
    Exit Sub

    SHOWCHOICE:
    _Blink Off

    Color 4, 1
    Locate 4, 54: Tprint "{RED}{213}" + String$(43, 205) + "{184}"
    Locate 5, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 6, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 7, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 8, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 9, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 10, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 11, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 12, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 13, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 14, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 15, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 16, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 17, 54: Tprint "{RED}{179}" + String$(43, 32) + "{179}"
    Locate 18, 54: Tprint "{192}" + String$(43, 196) + "{217}"

    Locate 5, 58
    Tprint "{WHT}USE{GRN}: {LIGHT GREEN}{24} {25} {26} {27} {GRAY 1} to make selection.    "

    Locate 6, 59
    Tprint "{LIGHT GREEN}F1{GRN}:{WHT} Do Conversion"

    Locate 15, 60: Tprint "{LIGHT GREEN}F3 {GRN}-{GRAY 1} Toggle Dithering {GRN}({WHT}ON{YEL}/{WHT}OFF{GRN})"
    Locate 16, 60: Tprint "{LIGHT GREEN}F4 {GRN}-{GRAY 1} Change color mode {GRN}({WHT}BPP{GRN})"
    Locate 17, 60: Tprint "{LIGHT GREEN}F5 {GRN}-{WHT} Palette{GRAY 1} Mode "

    Color 6, 0
    Locate 7, 56: Tprint "{ORG}{201}" + String$(39, 205) + "{187}"
    Locate 8, 56: Tprint "{ORG}{186}" + String$(39, 32) + "{186}"
    Locate 9, 56: Tprint "{ORG}{186}" + String$(39, 32) + "{186}"
    Locate 10, 56: Tprint "{ORG}{186}" + String$(39, 32) + "{186}"
    Locate 11, 56: Tprint "{ORG}{186}" + String$(39, 32) + "{186}"
    Locate 12, 56: Tprint "{ORG}{186}" + String$(39, 32) + "{186}"
    Locate 13, 56: Tprint "{ORG}{186}" + String$(39, 32) + "{186}"
    Locate 14, 56: Tprint "{ORG}{200}" + String$(39, 205) + "{188}"

    Color 6, 0: Locate 9, 61

    Select Case BitMapChoice
        Case 1
            Tprint "{GRAY 2}({LIGHT BLUE}Normal Low{GRAY 2})"
            Locate 10, 3: Tprint " {YEL}=={RED}>"
            ImageWidth = 320
            ImageHeight = 240
        Case 2
            Tprint "{GRAY 2}({LIGHT BLUE}Normal High{GRAY 2})"
            Locate 14, 3: Tprint " {YEL}=={RED}>"
            ImageWidth = 640
            ImageHeight = 480
        Case 3
            Tprint "{GRAY 2}({LIGHT BLUE}Compressed Low{GRAY 2})"
            Locate 19, 3: Tprint " {YEL}=={RED}>"
            ImageWidth = 320
            ImageHeight = 120
        Case 4
            Tprint "{GRAY 2}({LIGHT BLUE}Compressed High {GRAY 1}[{WHT}1{GRAY 1}]{GRAY 2})"
            Locate 24, 3: Tprint " {YEL}=={RED}>"
            ImageWidth = 640
            ImageHeight = 120
        Case 5
            Tprint "{GRAY 2}({LIGHT BLUE}Compressed High {GRAY 1}[{WHT}2{GRAY 1}]{GRAY 2})"
            Locate 29, 3: Tprint " {YEL}=={RED}>"
            ImageWidth = 640
            ImageHeight = 140
        Case 6
            Tprint "{GRAY 2}({YEL}EXPERT{ORG} Mode {GRN}!{GRAY 2})"
            Locate 35, 3: Tprint "{YEL}=={RED}>"
    End Select

    Color 6, 0: Locate 8, 61
    Tprint "{WHT}BitMap {LIGHT GREEN}" + _Trim$(Str$(BitMapChoice)) + "{GRN}"
    If BitMapChoice <> 6 Then Tprint ": {YEL}" + _Trim$(Str$(ImageWidth)) + "{GRN}x{YEL}" + _Trim$(Str$(ImageHeight))

    CheckTry:
    MovieFPS$ = GetDefaultFRM_Rate$

    If Val(MovieFPS$) < 4 And X_BITS > 1 Then
        BitsChanged = -1
        X_BITS = X_BITS - 1
        If X_BITS = 3 Then X_BITS = 2
        GoTo CheckTry
    End If

    Locate 11, 60: Print String$(22, 32);
    Locate 11, 60: Tprint "{WHT}  BPP: {YEL}" + _Trim$(Str$(X_BITS))
    Tprint "{WHT}    FPS: {LIGHT GREEN}"
    If UserChoice < 9 Then Print MovieFPS$; "   "; Else Tprint "{GRN}({YELLOW}tbd{GRN})"
    Locate 12, 60: Tprint "{WHT}  Dithering{GRN}:{YEL} "
    If UseDither Then
        Tprint "    ON "
    Else
        Tprint "    OFF"
    End If
    Locate 13, 59: Tprint "{WHT}Palette Mode{GRN}: "
    Select Case PalChoice
        Case BW_MODE
            Select Case X_BITS
                Case 1
                    Tprint "{GRAY 2}Black {GRAY 1}& {WHT}White"
                Case Else
                    Tprint "{GRAY 2}Gray Scale"
            End Select
        Case GRAY_MODE
            Tprint "{GRAY 2}Gray Scale"
        Case GREEN_MODE
            Tprint "{GRN}Green {LIGHT GREEN}"
        Case AMBER_MODE
            Tprint "{ORG}Amber {YEL}"
        Case COLOR_MODE
            Select Case X_BITS
                Case 4
                    Tprint "{LIGHT GREEN}4 {YEL}bpp {GRAY 1}color."
                Case Else
                    Tprint "{YEL}Allow {LIGHT BLUE}C{LIGHT RED}o{YEL}l{WHT}o{LIGHT GREEN}r"
            End Select
    End Select

    Color 15, 1
    Locate 19, 60: Tprint "{LIGHT GREEN}F10 {GRN}- {YEL}Switch back to Sprite Mode"
    Return

    CLEARLAST:
    Select Case LastChoice
        Case 1
            Locate 10, 3
        Case 2
            Locate 14, 3
        Case 3
            Locate 19, 3
        Case 4
            Locate 24, 3
        Case 5
            Locate 29, 3
        Case 6
            Locate 35, 3
    End Select
    Color 15, 1
    If LastChoice > 0 And LastChoice < 7 Then Print String$(4, 32);
    Return

    SaveSettings:
    SaveWidth = ImageWidth
    SaveHeight = ImageHeight
    SaveChoice = BitMapChoice
    SaveLast = LastChoice
    SaveDither = UseDither
    SaveColorOnly:
    SaveGray = GrayScaleVideo
    SaveBits = X_BITS
    SavePalChoice = PalChoice
    Return

    RestoreSettings:
    ImageWidth = SaveWidth
    ImageHeight = SaveHeight
    BitMapChoice = SaveChoice
    LastChoice = SaveLast
    UseDither = SaveDither
    RestoreColorOnly:
    GrayScaleVideo = SaveGray
    X_BITS = SaveBits
    PalChoice = SavePalChoice
    Return

    SPACEIT:
    Print: Print
    Return
End Sub

Sub ForceBW
    CVal1 = VERAPAL(0).GB + VERAPAL(0).R
    CVal2 = VERAPAL(1).GB + VERAPAL(1).R
    DoSwap = (CVal1 > CVal2)
    If DoSwap Then
        VERAPAL(1).GB = 0
        VERAPAL(1).R = 0
        VERAPAL(0).GB = &HFF
        VERAPAL(0).R = &H0F
    Else
        VERAPAL(0).GB = 0
        VERAPAL(0).R = 0
        VERAPAL(1).GB = &HFF
        VERAPAL(1).R = &H0F
    End If
    ImagePalette(0) = VERA2RGB(VERAPAL(0))
    ImagePalette(1) = VERA2RGB(VERAPAL(1))
End Sub

Sub InjectGreenPal
    Select Case X_BITS
        Case 1
            PalEnd = 1
        Case 2
            PalEnd = 3
        Case 4
            PalEnd = 15
    End Select
    For I = 0 To PalEnd
        VERAPAL(I).GB = _ShL(VPAL_AVERAGE(VERAPAL(I)), 4)
        VERAPAL(I).R = 0
        ImagePalette(I) = VERA2RGB(VERAPAL(I))
    Next
End Sub

Sub InjectAmberPal
    GMask = &HA0
    Rmask = &H0E

    Select Case X_BITS
        Case 1
            PalEnd = 1
        Case 2
            PalEnd = 3
        Case 4
            GMask = &HB0
            Rmask = &H0F
            PalEnd = 15
    End Select

    For I = 0 To PalEnd
        GVal = VPAL_AVERAGE(VERAPAL(I))

        Rem _Dest _Console
        Rem Print GVal

        Select Case GVal
            Case 14, 15
                VERAPAL(I).GB = &HB0
                VERAPAL(I).R = &HF
            Case 12, 13
                VERAPAL(I).GB = &H90
                VERAPAL(I).R = &HC
            Case 10, 11
                VERAPAL(I).GB = &H80
                VERAPAL(I).R = &HA
            Case 8, 9
                VERAPAL(I).GB = &H60
                VERAPAL(I).R = 8
            Case 6, 7
                VERAPAL(I).GB = &H40
                VERAPAL(I).R = 6
            Case 4, 5
                VERAPAL(I).GB = &H30
                VERAPAL(I).R = 4
            Case 2, 3
                VERAPAL(I).GB = &H20
                VERAPAL(I).R = 3
            Case 1
                VERAPAL(I).GB = &H10
                VERAPAL(I).R = 2
            Case 0
                Rem do nothing
        End Select
        ImagePalette(I) = VERA2RGB(VERAPAL(I))
    Next
End Sub


Sub ShowStats
    _Dest 0
    Color 15, 1
    Cls
    Color 7
    For I = 1 To 7: Print: Next
    ShowLogo
    Color 10
    Print "   SOURCE VIDEO: ";

    Color 14
    Print GetFileName(DName$) + GetFileExt(DName$);
    Print
    Color 10
    Print " X16 Movie File: ";
    Color 14: Print GetFileName(MovieName$) + GetFileExt(MovieName$)
    Print
    Print
    Color 10
    Print "      Frame Count:";
    Color 14
    Print FrameCount
    Print
    Color 10
    Print "        BIT DEPTH: ";
    Color 14
    If GrayScaleVideo Then
        Color 7
        Print "Gray Scale, ";
        Color 14: Print "4";

    ElseIf Make4BPP Then
        Print "4";
    Else
        Print "8";
    End If
    Color 2
    Print "bpp"
    Print
    Color 10
    Print " Palette Shifting: ";
    Color 14
    If Not Make4BPP And Not NO_PALETTE_SHIFTING Then
        Print "ON"
    Else
        Print "OFF"
    End If
    Print
    Color 15
    Print "     X";
    Color 10
    Print " Resolution:";
    Color 14
    Print ImageWidth
    Print
    Color 15
    Print "     Y ";
    Color 10
    Print "Resolution:";
    Color 14
    Print ImageHeight
    _Font 16
End Sub


Sub GetColCount
    ColorChoiceMessage
    getcolorcount:
    CFlag = 0
    DefUse$ = UsedCols$
    If DefUse$ = "" Then DefUse$ = "224"
    MSG$ = "Enter # of Palette colors to Use. (16-256)"
    X$ = _InputBox$("How Many Colors", MSG$, DefUse$)
    X$ = Left$(_Trim$(UCase$(X$)), 4)
    If X$ = "" Then System

    If X$ = "GRAY" Or X$ = "GREY" Then
        X$ = "16"
        GrayScaleVideo = -1
        GoTo endcolorfunction
    End If

    If Not IsNum(X$) Then
        _MessageBox "INVALID INPUT", "TRY AGAIN", "error"
        GoTo getcolorcount
    End If
    C% = Val(X$)
    If C% < 2 Or C% > 256 Then
        _MessageBox "INVALID INPUT", "TRY AGAIN", "error"
        GoTo getcolorcount
    End If
    endcolorfunction:
    UsedCols$ = X$
End Sub

Function GetTargetName$ ()
    CFlag = 0
    DefVal$ = GetFileName(DName$) + ".SPV"
    MSG$ = "Output File Name:"
    X$ = _InputBox$("OUTPUT MOVIE", MSG$, DefVal$)
    If GetFileExt(X$) = "" Then X$ = X$ + ".SPV"
    GetTargetName = X$
End Function


Sub CountFrames (ext$)
    Cls: Print: Color 11
    Locate 2, 2: Print "Counting Frames"
    SUFFIX$ = "0000000"
    FrameCount = 0
    Current& = 1
    Do
        If Current& = 10 Then SUFFIX$ = "000000"
        If Current& = 100 Then SUFFIX$ = "00000"
        If Current& = 1000 Then SUFFIX$ = "0000"
        If Current& = 10000 Then SUFFIX$ = "000"
        If Current& = 100000 Then SUFFIX$ = "00"
        CHKFILE$ = SUFFIX$ + Mid$(Str$(Current&), 2) + ext$
        If _FileExists(CHKFILE$) Then FrameCount = FrameCount + 1
        Current& = Current& + 1
    Loop While _FileExists(CHKFILE$)
    Cls
End Sub

Sub MonitorFrames (ext$)
    ChDir "frames"
    _Delay .5
    GetCount:
    LastCount = 0
    Counts = 0
    Do Until Counts > 3
        ReCount:
        Current& = 1
        MCount = 0
        SUFFIX$ = "0000000"
        Do
            If Current& = 10 Then SUFFIX$ = "000000"
            If Current& = 100 Then SUFFIX$ = "00000"
            If Current& = 1000 Then SUFFIX$ = "0000"
            If Current& = 10000 Then SUFFIX$ = "000"
            If Current& = 100000 Then SUFFIX$ = "00"
            CHKFILE$ = SUFFIX$ + Mid$(Str$(Current&), 2) + ext$
            If _FileExists(CHKFILE$) Then MCount = MCount + 1
            Current& = Current& + 1
            Rem Locate 3, 2: Print Current&; " : "; CHKFILE$; " : "; _CWD$
        Loop While _FileExists(CHKFILE$)
        Locate 15, 2: Tprint "{WHT}EXTRACTED{RED}:{LIGHT GREEN}" + Str$(MCount)
        If LastCount <> MCount Then
            LastCount = MCount
            Counts = 0
        Else
            Counts = Counts + 1
            _Delay 1
        End If
    Loop
    FrameCount = LastCount
    ChDir ".." + Slash$
End Sub


Sub BadCommandLine ()
    Print "USAGE:    MakeMovie  <FRAMEDIR> or <MOVIEFILE>": Print
    System
End Sub

Function VERA2RGB& (Vpal As VPALTYPE)
    grn = Int(Vpal.GB / 16) * 16
    VERA2RGB = _RGB32(Vpal.R * 16, grn, (Vpal.GB - grn) * 16, 255)
End Function

Sub Showit
    Static InShow
    Static Show3&
    Static ImgX%, ImgY%
    If Not InShow Then _ScreenShow
    _Dest _Console

    If Not InShow Then
        ImgX% = 102
        ImgY% = 81
        If wid > hei Then
            xmult = 480 / wid
            ymult = 320 / hei
        Else
            If hei > wid Then
                xmult = 260 / wid
                ymult = 360 / hei
                ImgX% = 132
                ImgY% = 75
            Else
                xmult = 400 / hei
                ymult = 340 / wid
                ImgX% = 110
            End If
        End If
        Show& = _NewImage(wid * xmult, hei * ymult, 32)
        Show2& = _NewImage(wid, hei, 32)
        Show3& = _NewImage(640, 580, 32)
        Screen Show3&: _Title "Converting - " + GetFileName(MovieName$) + " (" + _Trim$(Str$(FrameCount)) + " frames)"
        Line (0, 0)-(639, 452), _RGB32(0, 0, 175), BF
        _PutImage (0, 0), XImage&, Show3&
        Line (0, 454)-(639, 454), _RGB32(180, 100, 100)
        Line (0, 455)-(639, 455), _RGB32(150, 70, 70)
        Line (0, 456)-(639, 456), _RGB32(85, 40, 40)
        Line (ImgX% - 8, ImgY% - 8)-(ImgX% + (wid * xmult) + 8, ImgY% + (hei * ymult) + 8), _RGB32(100, 110, 100), BF
        Line (ImgX% - 5, ImgY% - 5)-(ImgX% + (wid * xmult) + 5, ImgY% + (hei * ymult) + 5), _RGB32(45, 35, 45), BF
    End If

    _Dest Show2&
    PixIndx& = 0
    For Y = 0 To (hei - 1)
        For X = 0 To (wid - 1)
            PSet (X, Y), ImagePalette(ImageData(PixIndx&))
            PixIndx& = PixIndx& + 1
        Next X
    Next Y
    _PutImage , Show2&, Show&
    _PutImage (ImgX%, ImgY%), Show&, Show3&
    Rem     Screen Show&
    Rem     If Not InShow Then _ScreenShow
    _Dest _Console
    InShow = -1
End Sub

Sub ShowLogo
    _PutImage (0, 0), XImage&, MyScreen&
End Sub

Sub LoadImage (ImgFile$)
    Addquotes = InStr(ImgFile$, Chr$(32)) > 0
    If Not _FileExists(ImgFile$) Then
        _MessageBox "NOT FOUND", ImgFile$ + " NOT FOUND!", "error"
        Print
        BadFile = -1
        System
    End If

    If Addquotes Then ImgFile$ = Chr$(34) + ImgFile$ + Chr$(34)
    MagickIt ImgFile$, "IN.BMP"
    LOAD_IMAGE_DATA "IN.BMP"

    Kill "IN.BMP"
End Sub


Sub MagickIt (Infile$, Outfile$)
    $If WINDOWS Then
        MAGICK$="magick "
    $Else
        Magick$ = "convert "
    $End If
    _Dest 0
    Locate 30, 2
    Print "FRAME: ";
    _Dest _Console
    Locate 4, 1
    Color 14
    Print "FRAME: ";
    Color 11
    DualPrint Infile$

    Grey$ = ""
    If GrayScaleVideo Then Grey$ = " -colorspace Gray "

    CMD$ = Magick$ + Infile$ + " -compress none "
    Sz$ = Str$(ImageWidth) + "x" + Mid$(Str$(ImageHeight), 2) + "! "

    Print "ImageWidth: "; ImageWidth
    Print "sz: "; Sz$

    CMD$ = CMD$ + " -resize " + Sz$
    Dither$ = " -dither NONE "
    If UseDither Then Dither$ = " -dither FloydSteinberg "
    CMD$ = CMD$ + Dither$
    CMD$ = CMD$ + " -flip " + Grey$ + " -depth 8 "
    CMD$ = CMD$ + "-colors " + UsedCols$ + " -type palette BMP3:" + Outfile$
    DualPrint ""
    Color 15
    DualPrint "EXECUTING"
    Color 14
    DualPrint CMD$
    Shell CMD$
End Sub

Sub LOAD_IMAGE_DATA (INBMP$)
    Dim InPixels As _Unsigned _Byte
    Dim Pix(1 To 8) As _Unsigned _Byte
    Dim Pix1 As _Unsigned _Byte
    Dim Pix2 As _Unsigned _Byte

    Dim USED_Colors(0 To 255) As _Byte
    Dim BmpHeader As BMPHeaderType
    Dim ImageSize As _Unsigned Long
    Dim Pixels As _Unsigned Long
    Dim Pix As _Unsigned _Byte

    Open INBMP$ For Binary As #1
    Get #1, , BmpHeader

    pad = BmpHeader.wid Mod 4
    If pad > 0 Then pad = 4 - pad

    ImageSize = BmpHeader.hei * BmpHeader.wid
    ReDim ImageData(0 To (ImageSize - 1)) As _Unsigned _Byte
    wid = BmpHeader.wid
    hei = BmpHeader.hei

    a$ = BmpHeader.pal ' Pal is stored in a 1024 character string

    I% = 1

    PStart = 0

    If Bit_Map_Mode Then
        Select Case X_PALMODE
        End Select
    End If

    For PI% = PStart To 255
        b% = _Round(Asc(Mid$(a$, I%, 1)) \ 16) 'blue
        g% = _Round(Asc(Mid$(a$, I% + 1, 1)) \ 16) 'green
        r% = _Round(Asc(Mid$(a$, I% + 2, 1)) \ 16) 'red
        ' I% + 3 is alpha channel which we DO NOT use.
        gb% = Int((g% * 16) + b%)
        VERAPAL(PI%).GB = gb%
        VERAPAL(PI%).R = r%
        I% = I% + 4
        ImagePalette(PI%) = VERA2RGB(VERAPAL(PI%))
    Next PI%


    Seek #1, BmpHeader.offset + 1

    If BmpHeader.bpp = 1 Then
        IIndx = 0
        For I = 0 To (ImageSize / 8 - 1)
            Get #1, , InPixels
            For Ji = 1 To 8: Pix(Ji) = 0: Next

            If (InPixels And 128) = 128 Then Pix(1) = 1

            If (InPixels And 64) = 64 Then Pix(2) = 1

            If (InPixels And 32) = 32 Then Pix(3) = 1

            If (InPixels And 16) = 16 Then Pix(4) = 1

            If (InPixels And 8) = 8 Then Pix(5) = 1

            If (InPixels And 4) = 4 Then Pix(6) = 1

            If (InPixels And 2) = 2 Then Pix(7) = 1

            If (InPixels And 1) = 1 Then Pix(8) = 1
            For Ji = 1 To 8
                ImageData(IIndx) = Pix(Ji)
                IIndx = IIndx + 1
            Next
        Next
        GoTo skip8bpp
    End If

    If BmpHeader.bpp = 4 Then
        IIndx = 0
        For I = 0 To (ImageSize / 2 - 1)
            Get #1, , InPixels
            Pix2 = Int(InPixels / 16)
            Pix1 = InPixels And 15
            ImageData(IIndx) = Pix2
            IIndx = IIndx + 1
            ImageData(IIndx) = Pix1
            IIndx = IIndx + 1
        Next
        GoTo skip8bpp
    End If


    If pad = 0 Then
        Get #1, , ImageData()
    Else
        I = 0
        For Y = 1 To BmpHeader.hei
            For X = 1 To BmpHeader.wid
                Get #1, , ImageData(I)
                I = I + 1
            Next X
            For P = 1 To pad: Get #1, , Pix: Next P
        Next Y
    End If

    skip8bpp:
    For I = 0 To 255: USED_Colors(I) = 0: Next
    ColorsUsed = 0

    Rem Count How Many Colors are used in this image
    For I = 0 To ImageSize - 1
        If USED_Colors(ImageData(I)) = 0 Then
            USED_Colors(ImageData(I)) = -1
            ColorsUsed = ColorsUsed + 1
        End If
        If ColorsUsed = 256 Then Exit For
    Next I


    If Make4BPP Then NO_PALETTE_SHIFTING = -1
    Rem if greater than 252 colors then no point in shifting UP
    If NO_PALETTE_SHIFTING Then Close 1: Exit Sub

    Rem Shift Used Colors and Image data UP in the Palette
    Rem fill unused lower indices with VERA default values
    FreeToIndx = (256 - ColorsUsed) - 1

    SCANCOLOR = FreeToIndx + 1

    For ColIndx = 0 To FreeToIndx
        GotSubstituteColor = 0
        For Pixels = 0 To (ImageSize - 1)
            If ImageData(Pixels) = ColIndx Then
                If Not GotSubstituteColor Then
                    U = SCANCOLOR
                    CHECKCOL:
                    If USED_Colors(U) = 0 Then GoTo gotnextcol
                    If U < 255 Then
                        U = U + 1
                        GoTo CHECKCOL
                    End If
                    gotnextcol:
                    SwapPixel = U
                    USED_Colors(U) = -1
                    USED_Colors(ColIndx) = 0
                    VERAPAL(U) = VERAPAL(ColIndx)
                    ImagePalette(U) = VERA2RGB(VERAPAL(U))
                    GotSubstituteColor = -1
                End If
                ImageData(Pixels) = SwapPixel
            End If
        Next Pixels
    Next ColIndx

    Restore VERA_DEFAULT
    For I = 0 To FreeToIndx
        VERAPAL(I) = VERAPALDEFAULT(I)
        ImagePalette(I) = VERA2RGB(VERAPAL(I))
    Next I
    Close 1
End Sub

Sub GetSprite (X As Integer, Y As Integer)
    GoLine = Y
    SprIndex = 0
    For SLine = 0 To (SprHeight - 1)
        ImgIndex = ((GoLine * ImageWidth)) + (X)
        For I = ImgIndex To (ImgIndex + SprWidth) - 1
            Sprite(SprIndex) = ImageData(I)
            SprIndex = SprIndex + 1
        Next
        GoLine = GoLine + 1
    Next
End Sub

Sub Make4bitSprite
    Static EndIndx
    Dim p1 As _Unsigned _Byte
    Dim p2 As _Unsigned _Byte
    If EndIndx = 0 Then EndIndx = ((SprWidth * SprHeight) / 2) - 1
    SIndx8BPP = 0
    For SIndx4BPP = 0 To EndIndx
        p1 = Sprite(SIndx8BPP)
        SIndx8BPP = SIndx8BPP + 1
        p2 = Sprite(SIndx8BPP)
        SIndx8BPP = SIndx8BPP + 1
        Sprite4BPP(SIndx4BPP) = _ShL(p1, 4) Or p2
        Rem Print p1, p2, Sprite4BPP(SIndx4BPP)
    Next
End Sub

Sub Grab4BitPalette
    For I% = 0 To 15
        VERAPAL4BPP(I%) = VERAPAL(I%)
    Next
End Sub

Function GetFileExt$ (FName$)
    DOT$ = "."
    L = Len(FName$)
    TMP$ = ""
    If InStr(1, FName$, DOT$) = 0 Then GoTo Skipall
    For I = L To 1 Step -1
        C$ = Mid$(FName$, I, 1)
        TMP$ = C$ + TMP$
        If C$ = DOT$ Then Exit For
    Next I
    Skipall:
    GetFileExt = TMP$
End Function

Sub DualPrintXY (Text$, X%, Y%)
    _Dest 0
    Locate Y%, X%
    Print Text$;
    _Dest _Console
    Locate Y%, X%
    Print Text$;
End Sub

Sub DualPrint (Text$)
    _Dest 0
    Print Text$
    _Dest _Console
    Print Text$
End Sub

Sub SetMyScreen (W%, H%)
    If MyScreen& < 0 Then
        FreeMyScreen
        MyScreen& = 1
    End If
    MyScreen& = _NewImage(W%, H%, 256)
    Screen MyScreen&
    _ScreenShow
    _Font Myfont&
End Sub

Sub FreeMyScreen
    _ScreenHide
    Screen 0
    _FreeImage MyScreen&
End Sub

Sub Tprint (TStr$)
    Static ForeColor
    Static BackColor
    Static Inprog
    Dim TMP$
    Dim Token$
    If Not Inprog Then
        ForeColor = 15
        Inprog = -1
    Else
        Color ForeColor
    End If
    I = 1
    L = Len(TStr$)
    TMP$ = ""
    Token$ = ""
    InToken = 0
    Do
        GETNEXTCHAR:
        c$ = Mid$(TStr$, I, 1)
        If c$ = "{" And Not InToken Then InToken = -1: GotToken = 0: I = I + 1: GoTo GETNEXTCHAR

        If Not InToken Then
            Print c$;
        End If

        If (c$ <> "}") And InToken Then
            Token$ = Token$ + c$
        End If

        If InToken And c$ = "}" Then
            If Token$ = "" Then
                T$ = Mid$(TStr$, I + 1, 1)
                If T$ = "}" Then
                    Print "}";
                    InToken = 0
                    I = I + 1: GoTo nextloop
                End If
            End If

            If IsNum(Token$) Then
                Print Chr$(Val(Token$));
                Token$ = "": InToken = 0
                GoTo nextloop
            End If

            If CNum(Token$) <> -1 Then
                ForeColor = CNum(Token$)
                Color ForeColor
                InToken = 0
                Token$ = ""
                GoTo nextloop
            End If

            If Token$ = "{" Then
                Print "{";
                InToken = 0
                Token$ = ""
            Else
                Color 4
                Print "{"; Token$; "}";
                Color ForeColor
                InToken = 0
                Token$ = ""
            End If
        End If
        nextloop:
        I = I + 1
    Loop Until I > L
    Exit Sub
End Sub

Function CNum (Token$)
    c$ = UCase$(Token$)
    For I = 0 To 15
        If c$ = CString(I) Or c$ = CString_AKA(I) Then
            CNum = I
            Exit Function
        End If
    Next
    CNum = -1
End Function

Sub CONSOLE_LOGO
    _Dest _Console
    Print
    Color 5: Print "             "
    Color 5: Print "           "
    Color 4: Print "          "
    Color 12: Print "     "
    Color 10: Print "       "
    Color 2: Print "        "
    Color 11: Print "        "
    Color 11: Print "       "
    Color 3: Print "     "
    Color 3: Print "          "
    Color 9: Print "           "
    Color 1: Print "             "
End Sub

Function GetFileName$ (FName$)
    $If WINDOWS Then
        SLASH$ = "\"
    $Else
        Slash$ = "/"
    $End If

    TMP$ = ""
    T$ = GetFileExt(FName$)
    CUT = Len(T$)
    L = Len(FName$)
    Name$ = Left$(FName$, L - CUT)
    If InStr(1, TName$, Slash$) = 0 Then
        TMP$ = Name$
        GoTo Skiploop
    End If
    For I = Len(Name$) To 1 Step -1
        C$ = Mid$(Name$, I, 1)
        If C$ <> Slash$ Then
            TMP$ = C$ + TMP$
        Else
            Exit For
        End If
    Next I
    Skiploop:
    GetFileName = TMP$
End Function

Function GetFilePath$ (FName$)
    t1$ = GetFileExt(FName$)
    t2$ = GetFileName(FName$)
    L = Len(FName$) - (Len(t1$) + Len(t2$))
    GetFilePath$ = Left$(FName$, L)
End Function

Function IsNum% (PassedText As String)
    text$ = PassedText
    special$ = UCase$(Left$(text$, 2))
    Select Case special$
        Case "&H", "&B", "&O"
            'check for symbols on right side of value
            r3$ = Right$(text$, 3)
            Select Case r3$
                Case "~&&", "~%%", "~%&" 'unsigned int64, unsigned byte, unsigned offset
                    text$ = Left$(text$, Len(text$) - 3)
                Case Else
                    r2$ = Right$(text$, 2)
                    Select Case r2$
                        Case "~&", "##", "%&", "%%", "~%", "&&" 'unsigned long, float, offset, byte, unsigned integer, int64
                            text$ = Left$(text$, Len(text$) - 2)
                        Case Else
                            r$ = Right$(text$, 1)
                            Select Case r$
                                Case "&", "#", "%", "!" 'long, double, integer, single
                                    text$ = Left$(text$, Len(text$) - 1)
                            End Select
                    End Select
            End Select
            check$ = "0123456789ABCDEF"
            If special$ = "&O" Then check$ = "01234567"
            If special$ = "&B" Then check$ = "01"
            temp$ = Mid$(UCase$(text$), 2)
            For I = 1 To Len(temp$)
                If InStr(check$, Mid$(temp$, I, 1)) = 0 Then Exit For
            Next
            If I <= Len(temp$) Then IsNum = -1
        Case Else
            If _Trim$(Str$(Val(text$))) = text$ Then IsNum = -1
    End Select
End Function

Sub ErrorHalt (msg$)
    _MessageBox "Movie Maker Error", msg$, "error"
    System
End Sub


