

LOAD_MOVIE:
  OPEN 6,8,6,AUDIOTRACK$+",S,R"
  OPEN 4,8,4,FRAMEFILE$+",S,R"

  GOSUB GET.VIDEO.HEADER
  GOSUB SET.VIDEO.ATTRIBUTES
  GOSUB SET.AUDIOCODE

  IF VTYPE=3 THEN GOSUB CALCULATE.BITMAP:GOSUB SET.BITMAPCODE:GOTO CHECKBOOKMARK
  GOSUB CALCULATE.SPRITES
  GOSUB SET.SPRITECODE
CHECKBOOKMARK:
  USE.BOOKMARK = 0
  F$ = BASENAME$+".MARK":GOSUB FILEEXISTS
  IF FE% THEN GOTO GETBOOKMARK
RETURN
## TAIL CALL OPTIMIZATION


PLAY_MOVIE:
  IF VTYPE=1 THEN GOSUB SETUP.SPRITEMOVIE:GOTO PLAY_the_Movie
  IF VTYPE=3 THEN GOSUB SETUP.BITMAPMOVIE:GOTO PLAY_the_Movie
  SCREEN 1
  COLOR 4:PRINT:PRINT "VTYPE ERROR {WHT}";VTYPE:STOP

PLAY_the_Movie:
   COLOR 0,0:CLS
   IF NOT USE.BOOKMARK THEN SKIP.MARK.SEEK
      FRM.POS = INT((VIDPOS-32)/TOTAL.FRMSIZE)
      CHANNEL = 4
## SEEK TO THE BOOKMARKED VIDEO FRAME
      FILEPOS = VIDPOS:GOSUB SEEK.POSITION

      A.MULT = FRM.POS - 2
      IF ASIZE < 2049 THEN A.MULT = A.MULT-1
      IF A.MULT < 0 THEN A.MULT = 0
## SEEK TO THE CORRECT AUDIO POSITION FOR THE BOOKMARK
      FILEPOS = ASIZE * A.MULT
      CHANNEL = 6:GOSUB SEEK.POSITION

SKIP.MARK.SEEK:
   IF (BPP=4) AND DBLED THEN GOSUB HIDETEXT
   POKE R0L, VERA.RATE
   POKE R0H, VERA.CFG
   POKE R15L, 1
   BANK VIDPLAYER_BANK
   SYS $A000
   SYS CLRCHN
   USED.ESCAPE = (PEEK(MANEXIT)=$FF)
   IF USED.ESCAPE THEN GOSUB SETBOOKMARK:GOTO CLOSESTREAM
   GOSUB SCRATCHBOOKMARK
CLOSESTREAM:
   CLOSE 4
   CLOSE 6
RETURN

SETUP.SPRITEMOVIE:
IF BPP = 4 THEN SCR.NUM = $80
  IF BPP = 8 THEN SCR.NUM = 3
  SCREEN SCR.NUM
  IF SCR.NUM = 3 THEN COLOR 1,0:CLS
  IF SCR.NUM = $80 THEN RECT 0,0,319,239, $10

  DBLED = FRAME_HINT$ = "D" OR (FRAMEHEIGHT <= (FRAMEWIDTH/2))
  IF FULL_SCREEN THEN X.ORG=0:Y.ORG=0:GOSUB SET.FULLSCREEN
  GOSUB PAL2BLACK
  GOSUB SetUpSprites
## Initially zero out used VRAM
  BANK VIDPLAYER_BANK
  SYS CLEARALLBUFFERS
RETURN

SETUP.BITMAPMOVIE:
  SYS CLEAR_GRAPHBUFFER
  GOSUB SET.GRAPHMODE
  DBLED = FRAME_HINT$ = "D" OR (FRAMEHEIGHT <= (FRAMEWIDTH/2))
  IF FULL_SCREEN THEN X.ORG=0:Y.ORG=0:GOSUB SET.FULLSCREEN
RETURN

PRINT.MOVIE.INFO:
  COLOR 1,0
  CLS:PRINT
  PRINT "{WHT} Movie Name{GRN}: {LIGHT RED}";BASENAME$
  PRINT "{YEL}";NUMFRAMES;"{GREY 1} Frame";
  IF VTYPE = 3 THEN PRINT "{LIGHT GREEN} Bitmap {GREY 1}Based {WHT}VIDEO"
  IF VTYPE = 1 THEN PRINT "{LIGHT GREEN} Sprite {GREY 1}Based {WHT}VIDEO"
  IF USE.BOOKMARK THEN PRINT "{WHT} BOOKMARK AT FRAME{GRN}: {YEL}";INT(VIDPOS/TOTAL.FRMSIZE)
  PRINT

  PRINT "{WHT}         FRAME RATE IS: {LIGHT GREEN}";FPS;"{YEL}fps":PRINT
  PRINT "{WHT}    AUDIO FILE SIZE IS: {YEL}";AUD.FILESIZE;" {LIGHT RED}bytes"
  PRINT "{WHT}    AUDIOFRAME SIZE IS: {YEL}";ASIZE;" {LIGHT RED}bytes"
  PRATE = FN ROUND((VERA.RATE/128) * VERABASERATE)
  PRINT "{WHT}             VERA RATE: {LIGHT GREEN}";VERA.RATE;" {GREY 1}({WHT}Sample rate{GRN}";PRATE;"{YEL}hz{GREY 1})"
  PRINT
  PRINT "{WHT}           FRAME WIDTH: {YEL}";FRAMEWIDTH
  PRINT "{WHT}          FRAME HEIGHT: {YEL}";FRAMEHEIGHT
  IF VTYPE = 1 THEN PRINT "{WHT}          SPRITE WIDTH: {LIGHT GREEN}";SPRWIDTH
  IF VTYPE = 1 THEN PRINT "{WHT}         SPRITE HEIGHT: {LIGHT GREEN}";SPRHEIGHT
  FSIZE = FRAMEWIDTH*FRAMEHEIGHT
  IF BPP = 4 THEN SDIVISOR = 2
  IF BPP = 2 THEN SDIVISOR = 4
  IF BPP = 1 THEN SDIVISOR = 8
  IF BPP < 8 THEN FSIZE = FSIZE/SDIVISOR
  PRINT "{WHT}            FRAME SIZE: {YEL}";FSIZE;" {LIGHT RED}bytes"
  PRINT
  IF VTYPE = 1 THEN PRINT "{WHT}         ATTR END ADDR: {LIGHT GREEN} ";HEX$(SPR.ATTR.ENDADDR)
  IF VTYPE = 1 THEN PRINT "{WHT}      BLOCK2 DATA ADDR: {LIGHT GREEN} ";HEX$(SPR.BLOCK2.DATAADDR):PRINT
  PRINT "{WHT}  Vid Buffer 255 Count:{GRN} "; SBuff255
  PRINT "{WHT}  Vid Buffer Remainder:{GRN} "; SBuffRem;" {LIGHT RED}bytes"
  PRINT
  IF VTYPE = 1 THEN PRINT "     {WHT}Number of Sprites:{LIGHT GREEN} ";NUMSPRITES:PRINT
  PRINT "{WHT}           COLOR DEPTH: {LIGHT GREEN}";BPP;"{YEL} bits per pixel"
  PRINT
RETURN

SETBOOKMARK:
 CHANNEL=4:GOSUB GETFILEPOSITION
 OPEN 7,8,7,"@:"+BASENAME$+".MARK,S,W"
 PRINT# 7, FILEPOS
 CLOSE 7
RETURN

GETBOOKMARK:
  OPEN 7,DEVICE,7,BASENAME$+".MARK,S,R"
  INPUT# 7, VIDPOS
  CLOSE 7
  USE.BOOKMARK = (VIDPOS>0)
RETURN

SCRATCHBOOKMARK:
  F$=BASENAME$+".MARK":GOSUB FILEEXISTS
  IF NOT FE% THEN RETURN
  COMMAND$ = "S:"+ F$
  GOTO DOS.CMD

SET.FULLSCREEN:
  X.SCALE = FN H.FULL_SCALE(FRAMEWIDTH)
  Y.SCALE = FN V.FULL_SCALE(FRAMEHEIGHT)

  TALLVIDEO = FRAME_HINT$="T" OR FRAMEWIDTH <= (FRAMEHEIGHT/1.5)

  IF TALLVIDEO THEN X.SCALE = Y.SCALE-1:X.ORG = ((640 * (X.SCALE/128)) - FRAMEWIDTH)/2:X.ORG = FN ROUND(X.ORG)

  POKE VERA.HSCALE, X.SCALE
  POKE VERA.VSCALE, Y.SCALE
RETURN

SET.AUDIOCODE:
  CHANNEL = 6
  GOSUB GETFILESIZE
  AUD.FILESIZE = FILESIZE
  ASIZE = FILESIZE / NUMFRAMES
  ASIZE = FN ROUND(ASIZE)
  DRATE = ASIZE*FPS
  VERA.RATE = FN ROUND((DRATE/VERABASERATE) * VERARATEDIVISOR)
  APLOOPS = 1
  IF ASIZE < 2048 THEN APLOOPS = 2
  M255 = INT(ASIZE/255)
  AREMAINDER = ASIZE - (255*M255)
  IF AREMAINDER = 0 THEN AREMAINDER = 255:M255 = M255-1
  BANK 10
  POKE R0L, APLOOPS
  POKE R0H, M255
  POKE R1L, AREMAINDER
  POKE R1H, M255
  POKE R2L, AREMAINDER
  BANK 10
  SYS SETAUDIOREAD
RETURN

CALCULATE.SPRITES:
  SPR.DATA.SIZE = SPRHEIGHT * SPRWIDTH
  IF BPP = 4 THEN SPR.DATA.SIZE = SPR.DATA.SIZE/2
  SPR.FRAME.SIZE = SPR.DATA.SIZE * NUMSPRITES
  TOTAL.FRMSIZE = (SPR.DATA.SIZE * NUMSPRITES)+PALSIZE
  SPR.ATTR.ENDADDR = $FC06 + (NUMSPRITES*8*2)
  SPR.BLOCK2.DATAADDR = SPRITE.ORIG.ADDR+(SPR.FRAME.SIZE) + PALSIZE
RETURN

CALCULATE.BITMAP:
  BITDIVISOR = 1
  IF BPP = 4 THEN BITDIVISOR = 2:PALSIZE = 32
  IF BPP = 2 THEN BITDIVISOR = 4:PALSIZE = 8
  IF BPP = 1 THEN BITDIVISOR = 8:PALSIZE = 4
  BIT.FRMSIZE = (FRAMEWIDTH * FRAMEHEIGHT) /  BITDIVISOR
  TOTAL.FRMSIZE = BIT.FRMSIZE + PALSIZE
RETURN

SET.BITMAPCODE:
  SBuff255 = INT(BIT.FRMSIZE/255)
  SBuffRem = BIT.FRMSIZE - (255*SBuff255)
  IF SBuffRem = 0 THEN SBuffRem = 255:SBuff255=SBuff255 - 1
  IF FRAMEWIDTH = 320 THEN POKE R2L, 0
  IF FRAMEWIDTH = 640 THEN POKE R2L, 1
  POKE R3L, SBuff255
  POKE R3H, SBuffRem
  POKE R4L, PALSIZE
  SYS SETVIDREAD_BITMAP
RETURN

SET.SPRITECODE:
  SBuff255 = INT(SPR.FRAME.SIZE/255)
  SBuffRem = SPR.FRAME.SIZE - (255*SBuff255)
  IF SBuffRem = 0 THEN SBuffRem = 255:SBuff255=SBuff255 - 1
  POKE R3L, SBuff255
  POKE R3H, SBuffRem
  POKE R4L, NUMSPRITES
  POKE R5L, FN Lo.Byte(SPR.ATTR.ENDADDR)
  POKE R5H, FN Hi.Byte(SPR.ATTR.ENDADDR)
  POKE R6L, FN Lo.Byte(SPR.BLOCK2.DATAADDR)
  POKE R6H, FN Hi.Byte(SPR.BLOCK2.DATAADDR)
  BANK VIDPLAYER_BANK
  IF BPP = 4 THEN SYS  SETSPRITEREAD_4BPP:RETURN
  SYS SETSPRITEREAD_8BPP
RETURN

SET.GRAPHMODE:
  IF FRAMEWIDTH = 640 THEN SCREEN 0:GOTO SKIP.SYSTEMGRAPH
  IF FRAMEWIDTH <> 320 THEN PRINT "{LIGHT RED}WIDTH ERROR{LIGHT GREEN}:{WHT}";FRAMEWIDTH:STOP
  SCREEN $80
SKIP.SYSTEMGRAPH:
  SYS CLEAR_GRAPHBUFFER
  GOSUB SHOWGRAPHICS
  COLOR 1,0:CLS
  IF BPP = 1 THEN GOTO SET1BPP
  IF BPP = 2 THEN GOTO SET2BPP
  IF BPP = 4 THEN GOTO SET4BPP
  PRINT "{LIGHT RED}BPP ERROR{LIGHT GREEN}:{WHT}";BPP:STOP

SET1BPP:
 POKE VERA.L0.CONFIG, %100
RETURN

SET2BPP:
 POKE VERA.L0.CONFIG, %101
RETURN

SET4BPP:
 POKE VERA.L0.CONFIG, %110
RETURN

SetUpSprites:
   SPR.DEPTH = 1
   SPR.PAL1 = 0
   SPR.PAL2 = 0
   IF BPP = 4 THEN SPR.DEPTH = 0:SPR.PAL1 = 14:SPR.PAL2=15
   IF FORCE.GRAY THEN SPR.PAL1 = 1:SPR.PAL2 = 1
   S.WIDTH = -1
   IF SPRWIDTH = 64 THEN S.WIDTH = 3
   IF SPRWIDTH = 32 THEN S.WIDTH = 2
   IF SPRWIDTH = 16 THEN S.WIDTH = 1
   IF SPRWIDTH = 8 THEN S.WIDTH = 0
   IF S.WIDTH = -1 THEN PRINT "SPRITE ERROR: ";SPRWIDTH;" WIDTH VAR":STOP
   S.HEIGHT = -1
   IF SPRHEIGHT = 64 THEN S.HEIGHT = 3
   IF SPRHEIGHT = 32 THEN S.HEIGHT = 2
   IF SPRHEIGHT = 16 THEN S.HEIGHT = 1
   IF SPRHEIGHT = 8 THEN S.HEIGHT = 0
   IF S.HEIGHT = -1 THEN PRINT "SPRITE ERROR: ";SPRHEIGHT;" HEIGHT VAR":STOP
   Y1 = Y.ORG
   X1 = X.ORG
   VADDR=SPRITE.ORIG.ADDR
   VADD.ON = (SPR.DATA.SIZE*NUMSPRITES) + PALSIZE

   FOR SPR = 1 TO NUMSPRITES
     SPRMEM SPR,SPRITE.VBANK,VADDR
     SPRMEM SPR+NUMSPRITES,SPRITE.VBANK,VADDR+VADD.ON
     VADDR = VADDR + SPR.DATA.SIZE
     SPRITE SPR, 3, SPR.PAL1, 0, S.WIDTH, S.HEIGHT,SPR.DEPTH
     SPRITE SPR+NUMSPRITES, 0, SPR.PAL2, 0, S.WIDTH, S.HEIGHT,SPR.DEPTH
     MOVSPR SPR, X1,Y1
     MOVSPR SPR+NUMSPRITES, X1, Y1
     X1=X1+SPRWIDTH:IF X1>=X.ORG + FRAMEWIDTH THEN X1=X.ORG:Y1=Y1 + SPRHEIGHT
   NEXT
   IF BPP = 4 THEN RECT X.ORG,Y.ORG, X.ORG+(FRAMEWIDTH-1),Y.ORG+(FRAMEHEIGHT-1), 0
RETURN

BASENAME.TO.UPPER:
  L = LEN(BASENAME$)
  TMP$=""
  FOR I = 1 TO L
      C$=MID$(BASENAME$,I,1)
      C = ASC(C$)
      IF C > 96 AND C< 123 THEN C=C-32
      IF C > 192 AND C<219 THEN C=C-128
      TMP$=TMP$+CHR$(C)
  NEXT
  BASENAME$=TMP$
RETURN

GET.VIDEO.HEADER:
  VHEADER$ = RPT$(32,32)
  A = POINTER(VHEADER$)+1
  POKE X.REG, 4
  SYS CHKIN
  POKE A.REG, 32
  POKE X.REG, PEEK(A)
  POKE Y.REG, PEEK(A+1)
  POKE C.REG, 0
  SYS MACPTR
  SYS CLRCHN
RETURN

SET.VIDEO.ATTRIBUTES:
  ID$ = LEFT$(VHEADER$,4)
  IF ID$ <> "SPRV" THEN PRINT "BAD VIDEO FILE ID {RED}";ID$:PRINT:STOP
  VTYPE = ASC(MID$(VHEADER$,5,1))
  IF VTYPE<>1 AND VTYPE<>3 THEN PRINT "BAD VIDEO FILE TYPE {RED}";VTYPE:PRINT:STOP
  BPP = ASC(MID$(VHEADER$,6,1))
  GOSUB CHECK_BPP

  FPS = ASC(MID$(VHEADER$,7,1))
  SPRWIDTH = ASC(MID$(VHEADER$,8,1))
  SPRHEIGHT = ASC(MID$(VHEADER$,9,1))
  FRAMEWIDTH = ASC(MID$(VHEADER$,10,1)) + (256 * ASC(MID$(VHEADER$,11,1)))
  FRAMEHEIGHT = ASC(MID$(VHEADER$,12,1)) + (256 * ASC(MID$(VHEADER$,13,1)))
  NUMFRAMES = ASC(MID$(VHEADER$,14,1)) + (256 * ASC(MID$(VHEADER$,15,1))) + (65536 * ASC(MID$(VHEADER$,16,1)))
  FRAME_HINT$ = MID$(VHEADER$,18,1)
  IF VTYPE = 1 THEN NUMSPRITES = (FRAMEWIDTH/SPRWIDTH) * (FRAMEHEIGHT/SPRHEIGHT)
  IF VTYPE = 3 THEN RETURN
  PALSIZE = 512
  SPRITE.VBANK = 0
  SPRITE.ORIG.ADDR = 0
  IF BPP = 4 THEN PALSIZE = 0:SPRITE.VBANK = 1:SPRITE.ORIG.ADDR = $3000
RETURN

CHECK_BPP:
 IF VTYPE = 3 THEN CHECKBITMAPS
 IF BPP<>8 AND BPP<> 4 THEN PRINT "UNSUPPORTED SPRITE VIDEO FILE BPP {RED}";BPP:PRINT:STOP
 RETURN
CHECKBITMAPS:
 IF BPP=1 OR BPP=2 OR BPP=4 THEN RETURN
 PRINT "UNSUPPORTED BITMAP VIDEO FILE BPP {RED}";BPP:PRINT:STOP

LOADMLPLAYER:
 F$="PLAYVIDEO.V4B.BIN":GOSUB FILEEXISTS
 IF FE% THEN BLOAD "PLAYVIDEO.V4B.BIN",8,VIDPLAYER_BANK,$A000:RETURN
 PRINT "{YEL}PLAYVIDEO.V4B.BIN  {WHT}NOT FOUND {GRN}!"
 PRINT "{LIGHT GREEN}POKING THE CODE {GRN}!{YEL}."
 ADDR = $A000
 RESTORE VIDEOPLAYERCODE
 BANK VIDPLAYER_BANK
 ADDR = $A000
 FOR CODEBYTES = 0 TO -1 STEP 0
     READ C
     IF C < 0 THEN CODEBYTES = C:GOTO END_OF_LOOP
     POKE ADDR, C
     PRINT ".";
     ADDR = ADDR + 1
 END_OF_LOOP:
 NEXT
 PRINT
 CLS
RETURN

CLEANUPMOVIE:
   FOR I = 1 TO (NUMSPRITES*2):SPRITE I,0:NEXT
   SCREEN 0
   COLOR 1,6:CLS
   GOSUB SHOWTEXT
   GOSUB SETDEFPAL
RETURN

VIDEOPLAYERCODE:
DATA 76,30,160,76,239,163,76,133,164,76,161,164,76,216,164,76,15,165,76,50,165,76,245,163,76,29,164,76,71,164,165,2,133,50,133,67,165,3,9,12,133,51,156,255,191,165,1,72,100,1,100,112,100
DATA 113,156,60,159,169,128,141,59,159,165,51,141,59,159,169,2,133,102,162,6,32,198,255,169,6,133,103,162,61,160,159,169,255,56,32,68,255,198,103,208,242,162,61,160,159,169,114,56,32,68
DATA 255,198,102,208,224,169,6,133,103,100,32,165,50,141,60,159,32,78,161,165,112,201,0,208,81,162,6,32,198,255,173,39,159,41,8,240,249,162,61,160,159,169,255,56,32,68,255,162,61,160,159
DATA 169,255,56,32,68,255,165,112,201,0,208,43,165,50,141,60,159,169,4,133,103,162,61,160,159,169,255,56,32,68,255,198,103,208,242,162,61,160,159,169,114,56,32,68,255,32,183,255,208,20,32
DATA 189,254,208,21,165,113,201,0,208,86,32,78,161,165,54,208,72,128,154,169,255,133,112,128,235,156,60,159,32,204,255,32,228,255,201,17,208,3,32,121,164,201,43,208,3,32,80,165,201,145,208
DATA 3,32,107,164,201,45,208,3,32,63,165,201,27,240,12,201,32,240,42,165,50,141,60,159,76,209,160,169,255,141,255,191,133,113,133,112,128,171,169,255,133,113,76,122,160,165,112,201,0,208
DATA 3,76,122,160,32,204,255,104,133,1,96,32,228,255,201,27,240,199,201,32,240,2,128,243,169,0,128,189,162,4,32,198,255,169,70,133,2,165,32,240,19,162,54,160,254,169,73,32,208,161,100,32
DATA 156,32,159,156,33,159,128,23,162,14,160,252,169,65,32,208,161,169,1,133,32,169,0,141,32,159,169,72,141,33,159,169,16,141,34,159,162,35,160,159,169,255,56,32,68,255,198,2,208,242,162
DATA 35,160,159,169,70,56,32,68,255,173,32,159,133,52,173,33,159,133,53,162,35,160,159,169,255,56,32,68,255,162,35,160,159,169,255,56,32,68,255,162,35,160,159,169,2,56,32,68,255,32,183,255
DATA 133,54,96,142,32,159,140,33,159,141,34,159,169,1,141,37,159,165,52,141,32,159,165,53,141,33,159,169,16,141,34,159,156,37,159,162,35,160,35,169,12,203,141,35,159,202,208,250,156,35,159
DATA 136,208,250,156,32,159,169,250,141,33,159,169,17,141,34,159,162,32,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173
DATA 36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159
DATA 141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,202,208,157,96,162,4,32,198,255,169,35,133,2,165,32,240,25,162,54,160,254,169,73,32,243,162,162,192,134,38,100,32,156,32,159,169
DATA 48,141,33,159,128,27,162,14,160,252,169,65,32,243,162,162,224,134,38,169,1,133,32,169,0,141,32,159,169,83,141,33,159,169,17,141,34,159,162,35,160,159,169,255,56,32,68,255,198,2,208
DATA 242,162,35,160,159,169,35,56,32,68,255,165,38,141,32,159,169,251,141,33,159,169,17,141,34,159,162,35,160,159,169,32,56,32,68,255,32,183,255,133,54,96,203,142,32,159,140,33,159,141,34
DATA 159,162,35,160,35,169,12,141,35,159,202,208,250,156,35,159,136,208,250,165,38,141,32,159,169,251,141,33,159,169,17,141,34,159,173,35,159,141,98,165,173,35,159,141,99,165,156,32,159
DATA 169,250,141,33,159,173,98,165,141,35,159,173,99,165,141,35,159,96,162,4,32,198,255,169,37,133,104,203,169,1,141,37,159,165,57,141,32,159,169,251,141,33,159,169,17,141,34,159,156,37
DATA 159,141,34,159,169,250,141,33,159,156,32,159,173,36,159,141,35,159,173,36,159,141,35,159,165,32,240,26,169,76,5,55,141,47,159,169,15,141,49,159,169,192,133,57,100,32,156,32,159,156
DATA 33,159,128,30,169,1,133,32,169,0,5,55,141,47,159,169,14,141,49,159,169,224,133,57,169,0,141,32,159,169,152,141,33,159,169,16,141,34,159,162,35,160,159,169,255,56,32,68,255,198,104,208
DATA 242,162,35,160,159,169,165,56,32,68,255,165,57,141,32,159,169,251,141,33,159,169,17,141,34,159,162,35,160,159,165,64,56,32,68,255,32,183,255,133,54,96,32,71,164,32,29,164,156,32,159
DATA 156,33,159,169,16,141,34,159,169,0,162,50,156,35,159,156,35,159,156,35,159,156,35,159,156,35,159,156,35,159,26,208,235,202,208,232,96,156,32,159,169,176,141,33,159,169,17,141,34,159
DATA 169,0,162,10,156,35,159,156,35,159,156,35,159,156,35,159,156,35,159,156,35,159,26,208,235,202,208,232,96,156,32,159,169,48,141,33,159,169,17,141,34,159,169,0,162,32,156,35,159,156,35
DATA 159,156,35,159,156,35,159,26,208,241,202,208,238,96,72,173,59,159,26,137,15,240,3,141,59,159,104,96,72,173,59,159,58,48,3,141,59,159,104,96,165,2,141,68,160,165,3,141,77,160,165,4,141
DATA 99,160,165,5,58,58,141,172,160,165,6,141,194,160,96,165,8,141,84,161,165,9,141,157,161,165,10,141,241,161,141,243,161,165,12,141,92,161,165,13,141,94,161,165,14,141,124,161,165,15,141
DATA 129,161,169,78,162,161,141,120,160,141,216,160,142,121,160,142,217,160,96,165,8,141,124,162,165,9,141,207,162,165,10,141,254,162,141,0,163,165,12,141,132,162,165,13,141,134,162,165
DATA 14,141,174,162,165,15,141,179,162,169,118,162,162,141,120,160,141,216,160,142,121,160,142,217,160,96,165,8,141,69,163,165,9,141,203,163,165,6,133,55,165,10,133,64,169,63,162,163,141
DATA 120,160,141,216,160,142,121,160,142,217,160,96,142,120,160,142,216,160,140,121,160,140,217,160,96,96,165,67,201,1,240,9,58,156,60,159,141,60,159,133,67,96,96,165,67,201,128,240,9,26
DATA 133,67,156,60,159,141,60,159,96,0,0,0,-1

REM 1380  BYTES CONVERTED
