FLUSHKEYS:
  FOR V = 0 TO -1 STEP 0
      GET X$
      V = (X$="")
  NEXT V
  RETURN

PAL2BLACK:
   POKE VERA.LOWADDR, 0
   POKE VERA.MIDADDR, $FA
   POKE VERA.HIGHADDR, %00010001
   POKE R0L, $23
   POKE R0H, $9F
   POKE R1L, 0
   POKE R1H, 2
   POKE A.REG, 0
   SYS MEM.FILL
RETURN

GETFILEPOSITION:
 OPEN 15,8,15, "T" + CHR$(CHANNEL)
 INPUT#15,A,A$,T,S
 CLOSE 15
 IF A>=20 THEN FILEPOS = 0:RETURN
 FILEPOS=VAL("$"+LEFT$(A$,8))
RETURN

GETFILESIZE:
 OPEN 15,8,15, "T" + CHR$(CHANNEL)
 INPUT#15,A,A$,T,S
 CLOSE 15
 IF A>=20 THEN FILESIZE = 0:RETURN
 FILESIZE=VAL("$"+MID$(A$,9))
 RETURN

TestFileSystem:
 F$="FILESYSTEM.TEST":GOSUB FILEEXISTS
 IF FE% THEN StartTest
 OPEN 2,8,2,"@:FILESYSTEM.TEST,S,W"
 FOR I = 1 TO 100
     PRINT# 2, "ABCDEFGHIJKLMN"
 NEXT I
 CLOSE 2
StartTest:
 OPEN 2,8,2,"FILESYSTEM.TEST,S,R"
 POKE X.REG,2
 SYS CHKIN
 BANK 63
 POKE X.REG,$00
 POKE Y.REG,$A0
 POKE C.REG, 0
 POKE A.REG, 0
 SYS MACPTR
 IsHostFS = (PEEK(Y.REG) = 1)
 SYS CLRCHN
 CLOSE 2
 RETURN

CLEAR.GRAPHICSBUFFER:
  POKE VERA.LOWADDR, 0
  POKE VERA.MIDADDR, 0
  POKE VERA.HIGHADDR, %00010000
  POKE R0L, $23
  POKE R0H, $9F
  POKE R1L, $FF
  POKE R1H, $FF
  POKE A.REG, 0
  SYS MEM.FILL
  POKE VERA.LOWADDR, $FF
  POKE VERA.MIDADDR, $FF
  POKE VERA.HIGHADDR, %00010000
  POKE R0L, $23
  POKE R0H, $9F
  POKE R1L,$01
  POKE R1H,$2C
  POKE A.REG, 0
  SYS MEM.FILL
  RETURN

CLSALL:
 CLS
CLSGRAPH:
 RECT ZERO,ZERO,XLIMIT,YLIMIT,ZERO:RETURN

HIDEALL:
  GOSUB HIDEGRAPHICS:GOTO HIDETEXT
SHOWALL:
  GOSUB SHOWGRAPHICS:GOTO SHOWTEXT

HIDEGRAPHICS:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) AND LAYER0.OFF:RETURN

SHOWGRAPHICS:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) OR LAYER0.ON:RETURN

HIDETEXT:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) AND LAYER1.OFF:RETURN

SHOWTEXT:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) OR LAYER1.ON:RETURN

TEXTBOX:
  LOCATE Y,X:PRINT CHR$(DChars%(1));RPT$(DChars%(2),W-2);CHR$(DChars%(3));
  IF H=2 THEN SKIPMID
  BStart=Y+1:BEnd=Y+(H-2)
  FOR Y2 = BStart TO BEnd:LOCATE Y2,X:PRINT CHR$(DChars%(4));RPT$(32,W-2);CHR$(DChars%(5));:NEXT
SKIPMID:
  LOCATE Y+H-1,X:PRINT CHR$(DChars%(6));RPT$(DChars%(7),W-2);CHR$(DChars%(8));:RETURN

LoadDCharsCP437:
 RESTORE CP437DRAW
 GOTO Load.Them.Chars

LoadDChars:
  RESTORE PETSCIIDRAW
Load.Them.Chars:
  FOR I=1 TO 8
   READ DChars%(I)
  Next
  RETURN

PETSCIIDRAW:
 DATA $CF,$B7,$D0,$B4,$AA,$CC,$EF,$BA

CP437DRAW:
 DATA $C9,$CD,$BB,$BA,$BA,$C8,$CD,$BC

SEEK.POSITION:
  HIWORD = INT(FILEPOS/65536)
  LOWORD = FILEPOS - (HIWORD*65536)
  P0 = FN Lo.Byte(LOWORD)
  P1 = FN Hi.Byte(LOWORD)
  P2 = FN Lo.Byte(HIWORD)
  P3 = FN Hi.Byte(HIWORD)
  
POSITION:
  COMMAND$="P"+CHR$(CHANNEL)+CHR$(P0)+CHR$(P1)+CHR$(P2)+CHR$(P3)
  GOTO DOS.CMD

KILLFILE:
 GOSUB FILEEXISTS
 IF NOT FE% THEN RETURN
 COMMAND$="S:"+F$
 GOTO DOS.CMD

FILEEXISTS:
  FF$=F$:FE%=0:FF$=FF$+",S,R"
  OPEN 2,DEVICE,2,FF$:CLOSE 2
  GOSUB GETFILECODE
  FE%=(FCode<=20):RETURN

DOS.CMD:
 OPEN 15,DEVICE,15, COMMAND$
 GOTO GETFCODE

GETFILECODE:
  OPEN 15,8,15
GETFCODE:
  INPUT#15,FCode,FC$,A,B:CLOSE 15:RETURN

PLOTXY:
  POKE C.REG, 1
  SYS PLOT
  X=PEEK(Y.REG)+1
  Y=PEEK(X.REG)+1
  RETURN

SaveCursor.AndColor:
  SavedColor = PEEK(COLOR.BYTE)
  POKE C.REG, 1
  SYS PLOT
  SavedX = PEEK(X.REG)
  SavedY = PEEK(Y.REG)
  RETURN

RestoreCursor.AndColor:
   POKE COLOR.BYTE, SavedColor
   POKE X.REG, SavedX
   POKE Y.REG, SavedY
   POKE C.REG, 0
   SYS PLOT
   RETURN

FIXCURSOR:
  FBASE=$9F*8+$F000
  FOR X=0 TO 6:VPOKE 1,FBASE+X,0:NEXT X
  VPOKE 1,FBASE+7,$FF

GetParamString:
 OldBank=PEEK(0)
 BANK 0
 ADDR=$BF00
 PARAM.STRING$=""
 FOR I = 0 TO 1 STEP 0
     C=PEEK(ADDR)
     IF C>0 THEN ADDR=ADDR+1
     PARAM.STRING$=PARAM.STRING$+CHR$(C)
     IF C=0 THEN I=1
 NEXT
 BANK OldBank:RETURN

PUTPARAMMSG:
   PARAM.STRING$=ZSM.MSG$

PutParamString:
  OldBank=PEEK(0)
  BANK 0
  ADDR=$BF00
  IF LEN(PARAM.STRING$)=0 THEN SKIPPUT
  FOR I=1 TO LEN(PARAM.STRING$)
    POKE ADDR, ASC(MID$(PARAM.STRING$,I))
    ADDR=ADDR+1
  NEXT
  POKE ADDR, 0
  RETURN

ClearParamBuffer:
   OB=PEEK(0):BANK 0
   FOR ADDR = $BF00 TO $BFFF:POKE ADDR, 0:NEXT
   BANK OB:RETURN

SAVE.SCREEN.MODE:
   POKE C.REG, 1
   SYS SCREEN.MODE
   SAVEDMODE = PEEK(A.REG)
   RETURN

RESTORE.SCREEN.MODE:
   SCREEN SAVEDMODE
   RETURN

Setup.Banked.Ram:
  POKE C.REG,1
  SYS MEM.TOP
  NUM.BANKS = PEEK(A.REG)
  IF NUM.BANKS=0 THEN NUM.BANKS=256
  HI.Bank=NUM.BANKS-1
  LO.Bank = 2
  Scratch.BANK = HI.Bank
  HI.Bank = HI.Bank - 1
  FREE.Banks = (HI.Bank-LO.Bank) + 1
  RETURN


STRINGGET:
     GET X$:IF X$<>"" THEN STRINGGET
     IS$="":ID=0
     GOSUB AREACLR:IF IS$="" THEN PRINT CHR$(95);
     IF IS$<> "" THEN PRINT IS$;CHR$(95);
GETAKEY3:
     GET X$:IF X$="" THEN GETAKEY3
     C=ASC(X$)
     AC=0
     IF (IT<>2 OR IT=3) AND C>=65 AND C<=123 THEN AC=1
     IF (IT=2 OR IT=4 OR IT=3) AND C>=48 AND C<=57 THEN AC=1
     IF ((IT=2) AND C=46 AND ID=0) OR IT=3 THEN AC=1:ID=1
     IF (IT=4) AND C=32 THEN AC=1: REM ALLOW SPACES WHEN INPUTTING A LINE
     IF (IT=4) AND (C>=35 AND C<=47) THEN AC=1
     IF (IT=4) AND (C>=58 AND C<=63) THEN AC=1  : REM ALLOW PUNCS IN STRING.
     IF C=13 THEN S$=IS$:GOSUB RTRIM:IS$=S$:RETURN
     IF ((AC=1 AND LEN(IS$)<ML) AND C<>20 AND C<>27) THEN IS$=IS$+CHR$(C):FMDRUM 7,26:LOCATE IY,IX:PRINT IS$;CHR$(95);:GOTO GETAKEY3
     IF C<>20 AND C<>27 THEN TOLONG
     AC=0
     IF (IS$="" OR IS$=CHR$(27)) AND C=27 THEN IS$=CHR$(27):RETURN
     IF LEN(IS$)=0 THEN FMDRUM 7,87
     IF LEN(IS$)=1 OR LEN(IS$)=0 THEN IS$="":GOSUB AREACLR:GOTO GETAKEYEND
     I=LEN(IS$)-1
     IF RIGHT$(IS$,1)="." AND IT=2 THEN ID=0
     S$=IS$
     I=LEN(S$)-1
     IS$=MID$(S$,1,I)
GETAKEYEND:
     GOSUB AREACLR:PRINT IS$;CHR$(95);:FMDRUM 7,26:GOTO GETAKEY3
TOLONG:
     FMDRUM 7,87:GOTO GETAKEY3

AREACLR:
     LOCATE IY,IX:PRINT RPT$(32,ML+1);
     LOCATE IY,IX
     RETURN

ERRORHALT:
  IF MSG$="" THEN MSG$=ERRMSG$
  COLOR 1,0
  PRINT
  COLOR 10,0
  PRINT "FATAL ERROR: ";
  COLOR 13,0
  PRINT MSG$;"{CR}{CR}"
  COLOR 1,0:END

UCASE:
  IF S$="" THEN RETURN
  X$="":FOR I=1 TO LEN(S$):I$=MID$(S$,I,1):X=ASC(I$):IF X>=97 AND X<=122 THEN X=X-32
  X$=X$+CHR$(X):NEXT I:S$=X$:RETURN

TRIM:
  GOSUB LTRIM:GOTO RTRIM

LTRIM:
   IF S$="" THEN RETURN
   I=1:C1=0
DOLOOP:
   X$=MID$(S$,I,1):X=ASC(X$):IF X > 32 THEN LSTR
   C1=C1+1:I=I+1:IF I>LEN(S$) THEN LSTR
   GOTO DOLOOP
LSTR:
   IF C1=LEN(S$) THEN S$=""
   IF C1>0 AND C1<LEN(S$) THEN S$=MID$(S$,C1+1,LEN(S$)-C1)
   RETURN

RTRIM:
  IF S$="" THEN RETURN
  I=LEN(S$):C1=0
DOLOOPR:
  X$=MID$(S$,I,1):X=ASC(X$):IF X>32 THEN RSTR
  C1=C1+1:I=I-1:IF I<1 THEN RSTR
  GOTO DOLOOPR
RSTR:
  IF C1=LEN(S$) THEN S$=""
  IF C1>0 AND C1<LEN(S$) THEN S$=MID$(S$,1,LEN(S$)-C1)
  RETURN

INSTR:
    ISTR=ZERO
    IF T$="" OR S$="" OR (LEN(S$)>LEN(T$)) THEN RETURN
    S=LEN(S$)
    L=LEN(T$)-(S-1)
TESTLOOP:
    TST$=MID$(T$,L,S)
    IF TST$=S$ THEN ISTR=L
    IF ISTR<>L AND L>1 THEN L=L-1:GOTO TESTLOOP
    RETURN


GET.FileExtension:
  EXT$ = ""
  L = LEN(F$)
  IF L<2 THEN RETURN
  FOR C = 0 TO 1 STEP 0
      X$=MID$(F$,L,1)
      EXT$= X$+EXT$
      IF X$="." THEN C=1:GOTO EELOOP
      L=L-1
      IF L=0 THEN C=1
EELOOP:
  NEXT C
  IF L=0 THEN EXT$=""
  RETURN

SETDEFPAL:
      F$="DPAL.BIN":GOSUB FILEEXISTS
      IF FE% THEN BVLOAD F$,8,1,$FA00:RETURN
      POKE $9F20, 0
      POKE $9F21, $FA
      POKE $9F22, %00010001
      RESTORE PALDATA
REM LOOP THROUGH THE PALLETTE ADDRESS SPACE
REM AND POKE THE VERA DEFAULT PALLETTE
      FOR PE = 1 TO 256:READ R:READ GB:POKE VERA.DATA0,GB:POKE VERA.DATA0,R:NEXT
      RETURN

REM DEFAULT VERA PALLETTE AS DATA. FROM 0 TO 255 (2 BYTES EACH ENTRY)RGB
PALDATA:
      DATA $00,$00,$0F,$FF,$08,$00,$0A,$FE,$0C,$4C,$00,$C5,$00,$0A,$0E,$E7,$0D
      DATA $85,$06,$40,$0F,$77,$03,$33,$07,$77,$0A,$F6,$00,$8F,$0B,$BB,$00,$00
      DATA $01,$11,$02,$22,$03,$33,$04,$44,$05,$55,$06,$66,$07,$77,$08,$88,$09
      DATA $99,$0A,$AA,$0B,$BB,$0C,$CC,$0D,$DD,$0E,$EE,$0F,$FF,$02,$11,$04,$33
      DATA $06,$44,$08,$66,$0A,$88,$0C,$99,$0F,$BB,$02,$11,$04,$22,$06,$33,$08
      DATA $44,$0A,$55,$0C,$66,$0F,$77,$02,$00,$04,$11,$06,$11,$08,$22,$0A,$22
      DATA $0C,$33,$0F,$33,$02,$00,$04,$00,$06,$00,$08,$00,$0A,$00,$0C,$00,$0F
      DATA $00,$02,$21,$04,$43,$06,$64,$08,$86,$0A,$A8,$0C,$C9,$0F,$EB,$02,$11
      DATA $04,$32,$06,$53,$08,$74,$0A,$95,$0C,$B6,$0F,$D7,$02,$10,$04,$31,$06
      DATA $51,$08,$62,$0A,$82,$0C,$A3,$0F,$C3,$02,$10,$04,$30,$06,$40,$08,$60
      DATA $0A,$80,$0C,$90,$0F,$B0,$01,$21,$03,$43,$05,$64,$07,$86,$09,$A8,$0B
      DATA $C9,$0D,$FB,$01,$21,$03,$42,$04,$63,$06,$84,$08,$A5,$09,$C6,$0B,$F7
      DATA $01,$20,$02,$41,$04,$61,$05,$82,$06,$A2,$08,$C3,$09,$F3,$01,$20,$02
      DATA $40,$03,$60,$04,$80,$05,$A0,$06,$C0,$07,$F0,$01,$21,$03,$43,$04,$65
      DATA $06,$86,$08,$A8,$09,$CA,$0B,$FC,$01,$21,$02,$42,$03,$64,$04,$85,$05
      DATA $A6,$06,$C8,$07,$F9,$00,$20,$01,$41,$01,$62,$02,$83,$02,$A4,$03,$C5
      DATA $03,$F6,$00,$20,$00,$41,$00,$61,$00,$82,$00,$A2,$00,$C3,$00,$F3,$01
      DATA $22,$03,$44,$04,$66,$06,$88,$08,$AA,$09,$CC,$0B,$FF,$01,$22,$02,$44
      DATA $03,$66,$04,$88,$05,$AA,$06,$CC,$07,$FF,$00,$22,$01,$44,$01,$66,$02
      DATA $88,$02,$AA,$03,$CC,$03,$FF,$00,$22,$00,$44,$00,$66,$00,$88,$00,$AA
      DATA $00,$CC,$00,$FF,$01,$12,$03,$34,$04,$56,$06,$68,$08,$8A,$09,$AC,$0B
      DATA $CF,$01,$12,$02,$24,$03,$46,$04,$58,$05,$6A,$06,$8C,$07,$9F,$00,$02
      DATA $01,$14,$01,$26,$02,$38,$02,$4A,$03,$5C,$03,$6F,$00,$02,$00,$14,$00
      DATA $16,$00,$28,$00,$2A,$00,$3C,$00,$3F,$01,$12,$03,$34,$05,$46,$07,$68
      DATA $09,$8A,$0B,$9C,$0D,$BF,$01,$12,$03,$24,$04,$36,$06,$48,$08,$5A,$09
      DATA $6C,$0B,$7F,$01,$02,$02,$14,$04,$16,$05,$28,$06,$2A,$08,$3C,$09,$3F
      DATA $01,$02,$02,$04,$03,$06,$04,$08,$05,$0A,$06,$0C,$07,$0F,$02,$12,$04
      DATA $34,$06,$46,$08,$68,$0A,$8A,$0C,$9C,$0F,$BE,$02,$11,$04,$23,$06,$35
      DATA $08,$47,$0A,$59,$0C,$6B,$0F,$7D,$02,$01,$04,$13,$06,$15,$08,$26,$0A
      DATA $28,$0C,$3A,$0F,$3C,$02,$01,$04,$03,$06,$04,$08,$06,$0A,$08,$0C,$09
      DATA $0F,$0B
